#include "QElantouchPad.h"


/*========================page General====================================*/

void	QElantouchPad::slot_touchpadoff_checkBox()
{

	sensitivity_label->setEnabled(touchpad_checkBox->isChecked() );
	max_speed_slider->setEnabled(touchpad_checkBox->isChecked() );
	general_img->setEnabled(touchpad_checkBox->isChecked() );


	Button_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Tapping_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Scrolling_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Zoom_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Rotation_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Swipe_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Fast_Keys_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Covergesture_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	PalmTracking_groupBox->setEnabled(touchpad_checkBox->isChecked() );

	
	this->apply_elanshm.SHM_touch_checkBox = !touchpad_checkBox->isChecked();
	#if debug_SHM_touch
		cout << "this->apply_elanshm.SHM_touch_checkBox=" << this->apply_elanshm.SHM_touch_checkBox << endl;
	#endif	
}

void	QElantouchPad::slot_maxspeed_slider()
{
	this->apply_elanshm.SHM_maxspeed_slider = max_speed_slider->value()/1000.0;
	#if debug_SHM_maxspeed
		cout << "this->apply_elanshm.SHM_maxspeed_side =" << this->apply_elanshm.SHM_maxspeed_slider << endl;
	#endif
}

/*========================page Button====================================*/

void	QElantouchPad::slot_button_checkBox()
{
	button_left_label->setEnabled(button_checkBox->isChecked() );
	button_middle_label->setEnabled(button_checkBox->isChecked() );
	button_right_label->setEnabled(button_checkBox->isChecked() );

	button_left_img->setEnabled(button_checkBox->isChecked() );
	button_middle_img->setEnabled(button_checkBox->isChecked() );
	button_right_img->setEnabled(button_checkBox->isChecked() );

	button_left_comboBox->setEnabled(button_checkBox->isChecked() );
	button_middle_comboBox->setEnabled(button_checkBox->isChecked() );
	button_right_comboBox->setEnabled(button_checkBox->isChecked() );

	button_img->setEnabled(button_checkBox->isChecked() );
	
	this->apply_elanshm.SHM_button_checkBox=button_checkBox->isChecked();
	#if debug_SHM_button_checkBox
		cout << "this->apply_elanshm.SHM_button_checkBox =" << this->apply_elanshm.SHM_button_checkBox << endl;
	#endif
}

void	QElantouchPad::slot_button_left_comboBox(int index)
{
	this->apply_elanshm.SHM_button_left_comboBox = index;
	#if debug_SHM_button_left_comboBox
		cout << "this->apply_elanshm.SHM_button_left_comboBox =" << this->apply_elanshm.SHM_button_left_comboBox << endl;
	#endif
}

void	QElantouchPad::slot_button_middle_comboBox(int index)
{
	this->apply_elanshm.SHM_button_middle_comboBox = index;
	#if debug_SHM_button_middle_comboBox
		cout << "this->apply_elanshm.SHM_button_middle_comboBox =" << this->apply_elanshm.SHM_button_middle_comboBox << endl;
	#endif
}


void	QElantouchPad::slot_button_right_comboBox(int index)
{
	this->apply_elanshm.SHM_button_right_comboBox = index;
	#if debug_SHM_button_right_comboBox
		cout << "this->apply_elanshm.SHM_button_right_comboBox =" << this->apply_elanshm.SHM_button_right_comboBox << endl;
	#endif
}

/*========================page Tapping====================================*/

void	QElantouchPad::slot_tapping_checkBox()
{
	one_finger_label->setEnabled(tapping_checkBox->isChecked() );	
	two_finger_label->setEnabled(tapping_checkBox->isChecked() );	
	three_finger_label->setEnabled(tapping_checkBox->isChecked() );

/*roger -2009.03.05
	if(key_when_type_checkBox->isChecked() )
	{
		tapping_delay_label->setEnabled(tapping_checkBox->isChecked() );
		cursor_delay_label->setEnabled(tapping_checkBox->isChecked() );
	}
*/

	one_finger_img->setEnabled(tapping_checkBox->isChecked() );
	two_finger_img->setEnabled(tapping_checkBox->isChecked() );
	three_fihger_img->setEnabled(tapping_checkBox->isChecked() );

	Tapping_label->setEnabled(tapping_checkBox->isChecked() );
	two_finger_comboBox->setEnabled(tapping_checkBox->isChecked() );
	three_finger_comboBox->setEnabled(tapping_checkBox->isChecked() );

/*roger -2009.03.05
	if(key_when_type_checkBox->isChecked())
	{
		tapping_delay_comboBox->setEnabled(tapping_checkBox->isChecked() );
		cursor_delay_comboBox->setEnabled(tapping_checkBox->isChecked() );
	}

	key_when_type_checkBox->setEnabled(tapping_checkBox->isChecked() );
*/	
	

	tapping_img->setEnabled(tapping_checkBox->isChecked() );

	this->apply_elanshm.SHM_tapping_checkBox = tapping_checkBox->isChecked();
	#if debug_SHM_tapping_checkBox
		cout << "this->apply_elanshm.SHM_tapping_checkBox =" << this->apply_elanshm.SHM_tapping_checkBox << endl;
	#endif
	
}

void	QElantouchPad::slot_two_FT_comboBox(int index)
{
	this->apply_elanshm.SHM_two_FT_comboBox = index;
	#if debug_SHM_two_FT_comboBox
		cout << "this->apply_elanshm.SHM_button_middle_comboBox =" << this->apply_elanshm.SHM_two_FT_comboBox << endl;
	#endif
}

void	QElantouchPad::slot_three_FT_comboBox(int index)
{
	this->apply_elanshm.SHM_three_FT_comboBox = index;
	#if debug_SHM_three_FT_comboBox
		cout << "this->apply_elanshm.SHM_three_FT_comboBox =" << this->apply_elanshm.SHM_three_FT_comboBox << endl;
	#endif
}

void	QElantouchPad::slot_disable_when_key_checkBox()
{
	tapping_delay_label->setEnabled(key_when_type_checkBox->isChecked());
	cursor_delay_label->setEnabled(key_when_type_checkBox->isChecked());

	tapping_delay_comboBox->setEnabled(key_when_type_checkBox->isChecked());
	cursor_delay_comboBox->setEnabled(key_when_type_checkBox->isChecked());
	cover_delay_comboBox->setEnabled(key_when_type_checkBox->isChecked());
	gesture_delay_comboBox->setEnabled(key_when_type_checkBox->isChecked());
	palm_delay_comboBox->setEnabled(key_when_type_checkBox->isChecked());

	this->apply_elanshm.SHM_disable_when_key_checkBox = key_when_type_checkBox->isChecked();
	#if debug_SHM_disable_when_key_checkBox
		cout << "this->apply_elanshm.SHM_disable_when_key_checkBox =" << this->apply_elanshm.SHM_disable_when_key_checkBox << endl;
	#endif
}

void	QElantouchPad::slot_tapping_delay_comboBox(int index)
{
	this->apply_elanshm.SHM_tapping_delay_comboBox = index;
	#if debug_SHM_tapping_delay_comboBox
		cout << "this->apply_elanshm.SHM_tapping_delay_comboBox =" << this->apply_elanshm.SHM_tapping_delay_comboBox << endl;
	#endif

}

void	QElantouchPad::slot_cursor_delay_comboBox(int index)
{
	this->apply_elanshm.SHM_cursor_delay_comboBox = index;
	#if debug_SHM_cursor_delay_comboBox
		cout << "this->apply_elanshm.SHM_cursor_delay_comboBox =" << this->apply_elanshm.SHM_cursor_delay_comboBox << endl;
	#endif

}

void	QElantouchPad::slot_cover_delay_comboBox(int index)
{
	this->apply_elanshm.SHM_cover_delay_comboBox = index;
	#if debug_SHM_cover_delay_comboBox
		cout << "this->apply_elanshm.SHM_cover_delay_comboBox =" << this->apply_elanshm.SHM_cover_delay_comboBox << endl;
	#endif

}

void	QElantouchPad::slot_gesture_delay_comboBox(int index)
{
	this->apply_elanshm.SHM_gesture_delay_comboBox = index;
	#if debug_SHM_gesture_delay_comboBox
		cout << "this->apply_elanshm.SHM_gesture_delay_comboBox =" << this->apply_elanshm.SHM_gesture_delay_comboBox << endl;
	#endif

}

void	QElantouchPad::slot_palm_delay_comboBox(int index)
{
	this->apply_elanshm.SHM_palm_delay_comboBox = index;
	#if debug_SHM_palm_delay_comboBox
		cout << "this->apply_elanshm.SHM_palm_delay_comboBox =" << this->apply_elanshm.SHM_palm_delay_comboBox << endl;
	#endif

}

/*========================page Drag====================================*/

void	QElantouchPad::slot_drag_checkBox()
{	
	lift_release_radioButton->setEnabled(drag_checkBox->isChecked());
	tap_again_radioButton->setEnabled(drag_checkBox->isChecked());
	tap_release_radioButton->setEnabled(drag_checkBox->isChecked());
	drag_slider->setEnabled(drag_checkBox->isChecked());
	drag_img->setEnabled(drag_checkBox->isChecked());

	this->apply_elanshm.SHM_drag_checkBox = drag_checkBox->isChecked();
	#if debug_SHM_drag_checkBox
		cout << "this->apply_elanshm.SHM_drag_checkBox =" << this->apply_elanshm.SHM_drag_checkBox << endl;
	#endif
}

void	QElantouchPad::slot_lift_release_radioButton()
{
	this->apply_elanshm.SHM_lift_release_radioButton = lift_release_radioButton->isChecked();
	this->apply_elanshm.SHM_tap_release_radioButton = tap_release_radioButton->isChecked();
	this->apply_elanshm.SHM_tap_again_radioButton = tap_again_radioButton->isChecked();
	#if debug_SHM_drag_checkBox
		cout << "this->apply_elanshm.SHM_lift_release_radioButton =" << this->apply_elanshm.SHM_lift_release_radioButton << endl;
	#endif
}

void	QElantouchPad::slot_tap_again_radioButton()
{
	this->apply_elanshm.SHM_lift_release_radioButton = lift_release_radioButton->isChecked();
	this->apply_elanshm.SHM_tap_again_radioButton = tap_again_radioButton->isChecked();
	this->apply_elanshm.SHM_tap_release_radioButton = tap_release_radioButton->isChecked();
	#if debug_SHM_drag_checkBox
		cout << "this->apply_elanshm.SHM_tap_again_radioButton =" << this->apply_elanshm.SHM_tap_again_radioButton << endl;
	#endif

}

void	QElantouchPad::slot_tap_release_radioButton()
{
	this->apply_elanshm.SHM_lift_release_radioButton = lift_release_radioButton->isChecked();
	this->apply_elanshm.SHM_tap_again_radioButton = tap_again_radioButton->isChecked();
	this->apply_elanshm.SHM_tap_release_radioButton = tap_release_radioButton->isChecked();
	#if debug_SHM_drag_checkBox
		cout << "this->apply_elanshm.SHM_tap_release_radioButton =" << this->apply_elanshm.SHM_tap_release_radioButton << endl;
	#endif

}

void	QElantouchPad::slot_drag_slider()
{
	this->apply_elanshm.SHM_drag_slider = drag_slider->value()/10.0;
	#if debug_SHM_drag_slider
		cout<<"this->apply_elanshm.SHM_drag_slider =" << this->apply_elanshm.SHM_drag_slider << endl;
	#endif
}

/*========================page Edge Scrolling==========================*/

void	QElantouchPad::slot_edge_v_scroll_checkBox()
{
	this->apply_elanshm.SHM_edge_v_scroll_checkBox = edge_vertical_scrolling_checkBox->isChecked();
	if(!edge_vertical_scrolling_checkBox->isChecked() && !edge_horizontail_scrolling_checkBox->isChecked())
	{
		edge_scroll_speed_groupBox->setEnabled(0);
		edge_scroll_area_groupBox->setEnabled(0);
		edge_scrolling_img->setEnabled(0);
	}
	else
	{
		edge_scroll_speed_groupBox->setEnabled(1);
		edge_scroll_area_groupBox->setEnabled(1);
		edge_scrolling_img->setEnabled(1);
	}

	#if debug_SHM_edge_v_scroll_checkBox
		cout << "this->apply_elanshm.SHM_edge_v_scroll_checkBox =" << this->apply_elanshm.SHM_edge_v_scroll_checkBox << endl;
	#endif
}

void	QElantouchPad::slot_edge_h_scroll_checkBox()
{
	this->apply_elanshm.SHM_edge_h_scroll_checkBox = edge_horizontail_scrolling_checkBox->isChecked();
	if(!edge_vertical_scrolling_checkBox->isChecked() && !edge_horizontail_scrolling_checkBox->isChecked())
	{
		edge_scroll_speed_groupBox->setEnabled(0);
		edge_scroll_area_groupBox->setEnabled(0);
		edge_scrolling_img->setEnabled(0);
	}
	else
	{
		edge_scroll_speed_groupBox->setEnabled(1);
		edge_scroll_area_groupBox->setEnabled(1);
		edge_scrolling_img->setEnabled(1);
	}
	#if debug_SHM_edge_h_scroll_checkBox
		cout << "this->apply_elanshm.SHM_edge_h_scroll_checkBox =" << this->apply_elanshm.SHM_edge_h_scroll_checkBox << endl;
	#endif
}

void	QElantouchPad::slot_edge_scroll_speed_slider()
{
	this->apply_elanshm.SHM_edge_scroll_speed_slider = edge_scrolling_speed_slider->value();
	#if debug_SHM_edge_scrolling_speed_slider
		cout << "this->apply_elanshm.SHM_edge_scroll_speed_slider =" << this->apply_elanshm.SHM_edge_scroll_speed_slider << endl;
	#endif
}

void	QElantouchPad::slot_edge_scroll_area_slider()
{
	this->apply_elanshm.SHM_edge_scroll_area_slider = edge_scrolling_area_slider->value();
	#if debug_SHM_edge_scrolling_area_slider
		cout << "this->apply_elanshm.SHM_edge_scroll_area_slider =" << this->apply_elanshm.SHM_edge_scroll_area_slider << endl;
	#endif
}

/*========================page Scrolling====================================*/

void	QElantouchPad::slot_vertical_scrolling_checkBox()
{
	if(!horizontail_scrolling_checkBox->isChecked()){
		scrolling_img->setEnabled(vertical_scrolling_checkBox->isChecked());
		scroll_speed_slider->setEnabled(vertical_scrolling_checkBox->isChecked());
	}
	if(vertical_scrolling_checkBox->isChecked()){
		scrolling_img->setEnabled(1);	
		scroll_speed_slider->setEnabled(1);
	}
	
	this->apply_elanshm.SHM_vertical_scrolling_checkBox = vertical_scrolling_checkBox->isChecked();
	#if debug_SHM_vertical_scrolling_checkBox
		cout << "this->apply_elanshm.SHM_vertical_scrolling_checkBox =" << this->apply_elanshm.SHM_vertical_scrolling_checkBox << endl;
	#endif
}


void	QElantouchPad::slot_horizontal_scrolling_checkBox()
{
	

	if(!vertical_scrolling_checkBox->isChecked()){
		scrolling_img->setEnabled(vertical_scrolling_checkBox->isChecked());
		scroll_speed_slider->setEnabled(vertical_scrolling_checkBox->isChecked());
	}
	if(horizontail_scrolling_checkBox->isChecked()){
		scrolling_img->setEnabled(1);
		scroll_speed_slider->setEnabled(1);	
		
	}
	
	this->apply_elanshm.SHM_horizontal_scrolling_checkBox = horizontail_scrolling_checkBox->isChecked();
	#if debug_SHM_horizontal_scrolling_checkBox
		cout << "this->apply_elanshm.SHM_horizontal_scrolling_checkBox =" << this->apply_elanshm.SHM_horizontal_scrolling_checkBox << endl;
	#endif
}

void	QElantouchPad::slot_scrolling_speed_slider()
{
	this->apply_elanshm.SHM_scrolling_speed_slider = scroll_speed_slider->value();
	#if debug_SHM_scrolling_speed_slider
		cout << "this->apply_elanshm.SHM_scrolling_speed_slider =" << this->apply_elanshm.SHM_scrolling_speed_slider << endl;
	#endif
}


void	QElantouchPad::slot_auto_scroll_checkBox()
{
	this->apply_elanshm.SHM_auto_scroll_checkBox = auto_scroll_checkBox->isChecked();
	#if debug_SHM_auto_scroll_checkBox
		cout << "this->apply_elanshm.SHM_auto_scroll_checkBox =" << this->apply_elanshm.SHM_auto_scroll_checkBox << endl;
	#endif
}

/*========================page Zoom====================================*/

void	QElantouchPad::slot_zoom_checkBox()
{
	shrink_label->setEnabled(zoom_checkBox->isChecked());
	expand_label->setEnabled(zoom_checkBox->isChecked());

	zoom_out_comboBox->setEnabled(zoom_checkBox->isChecked());
	zoom_in_comboBox->setEnabled(zoom_checkBox->isChecked());
	
	zoom_slider->setEnabled(zoom_checkBox->isChecked());

	zoom_img->setEnabled(zoom_checkBox->isChecked());
	
	this->apply_elanshm.SHM_zoom_checkBox = zoom_checkBox->isChecked();
	#if debug_SHM_zoom_checkBox
		cout << "this->apply_elanshm.SHM_zoom_checkBox =" << this->apply_elanshm.SHM_zoom_checkBox << endl;
	#endif
}

void	QElantouchPad::slot_zoom_out_comboBox(int index)
{
	this->apply_elanshm.SHM_zoom_out_comboBox = index;
	#if debug_SHM_zoom_out_comboBox
		cout << "this->apply_elanshm.SHM_zoom_out_comboBox =" << this->apply_elanshm.SHM_zoom_out_comboBox << endl;
	#endif
}

void	QElantouchPad::slot_zoom_in_comboBox(int index)
{
	this->apply_elanshm.SHM_zoom_in_comboBox = index;
	#if debug_SHM_zoom_in_comboBox
		cout << "this->apply_elanshm.SHM_zoom_in_comboBox =" << this->apply_elanshm.SHM_zoom_in_comboBox << endl;
	#endif
}

void 	QElantouchPad::slot_zoom_slider()
{
	this->apply_elanshm.SHM_zoom_slider = zoom_slider->value();
	#if debug_SHM_zoom_slider
		cout << "this->apply_elanshm.SHM_zoom_slider =" << this->apply_elanshm.SHM_zoom_slider << endl;
	#endif
}

/*========================page Rotation====================================*/

void	QElantouchPad::slot_rotation_checkBox()
{
	clockwise_label->setEnabled(rotation_checkBox->isChecked());
	counterclosewise_label->setEnabled(rotation_checkBox->isChecked());

	clockwise_comboBox->setEnabled(rotation_checkBox->isChecked());
	counterclockwise_comboBox->setEnabled(rotation_checkBox->isChecked());
	
	rotation_slider->setEnabled(rotation_checkBox->isChecked());

	rotation_img->setEnabled(rotation_checkBox->isChecked());
	
	this->apply_elanshm.SHM_rotation_checkBox = rotation_checkBox->isChecked();
	#if debug_SHM_zoom_checkBox
		cout << "this->apply_elanshm.SHM_rotation_checkBox =" << this->apply_elanshm.SHM_rotation_checkBox << endl;
	#endif
}

void	QElantouchPad::slot_clockwise_comboBox(int index)
{
	this->apply_elanshm.SHM_clockwise_comboBox = index;
	#if debug_SHM_clockwise_comboBox
		cout << "this->apply_elanshm.SHM_clockwise_comboBox =" << this->apply_elanshm.SHM_clockwise_comboBox << endl;
	#endif
}

void	QElantouchPad::slot_counterclosewise_comboBox(int index)
{
	this->apply_elanshm.SHM_counterclosewise_comboBox = index;
	#if debug_SHM_counterclosewise_comboBox
		cout << "this->apply_elanshm.SHM_counterclosewise_comboBox =" << this->apply_elanshm.SHM_counterclosewise_comboBox << endl;
	#endif
}

void 	QElantouchPad::slot_rotation_slider()
{
	this->apply_elanshm.SHM_rotation_slider = rotation_slider->value();
	#if debug_SHM_rotation_slider
		cout << "this->apply_elanshm.SHM_rotation_slider =" << this->apply_elanshm.SHM_rotation_slider << endl;
	#endif
}


/*========================page Swipe====================================*/
	
void	QElantouchPad::slot_swipe_page_checkBox()
{
	page_up_img->setEnabled(swipe_checkBox->isChecked());
	page_down_img->setEnabled(swipe_checkBox->isChecked());

	page_up_label->setEnabled(swipe_checkBox->isChecked());
	page_down_label->setEnabled(swipe_checkBox->isChecked());

	swipe_img->setEnabled(swipe_checkBox->isChecked());

	this->apply_elanshm.SHM_swipe_page_checkBox = swipe_checkBox->isChecked();
	#if debug_SHM_swipe_page_checkBox
		cout << "this->apply_elanshm.SHM_swipe_page_checkBox =" << this->apply_elanshm.SHM_swipe_page_checkBox << endl;
	#endif
}

/*========================page Fast_keys====================================*/

void	QElantouchPad::slot_fast_key_checkBox()
{
	my_home_file_img->setEnabled(fast_keys_checkBox->isChecked());
	switch_windows_img->setEnabled(fast_keys_checkBox->isChecked());

	my_home_file_checkBox->setEnabled(fast_keys_checkBox->isChecked());
	switch_windows_checkBox->setEnabled(fast_keys_checkBox->isChecked());

	fast_keys_img->setEnabled(fast_keys_checkBox->isChecked());

	this->apply_elanshm.SHM_fast_key_checkBox = fast_keys_checkBox->isChecked();
	#if debug_SHM_fast_key_checkBox
		cout << "this->apply_elanshm.SHM_fast_key_checkBox =" << this->apply_elanshm.SHM_fast_key_checkBox << endl;
	#endif
}

void	QElantouchPad::slot_my_home_file_checkBox()
{
	my_home_file_img->setEnabled(my_home_file_checkBox->isChecked());
	
	if(!switch_windows_checkBox->isChecked())
		fast_keys_img->setEnabled(my_home_file_checkBox->isChecked());
	if(my_home_file_checkBox->isChecked())
		fast_keys_img->setEnabled(1);

	this->apply_elanshm.SHM_my_home_file_checkBox = my_home_file_checkBox->isChecked();
	#if debug_SHM_my_home_file_checkBox
		cout << "this->apply_elanshm.SHM_my_home_file_checkBox =" << this->apply_elanshm.SHM_my_home_file_checkBox << endl;
	#endif
}

void	QElantouchPad::slot_switch_windows_checkBox()
{
	switch_windows_img->setEnabled(switch_windows_checkBox->isChecked());
	
	if(!my_home_file_checkBox->isChecked())
		fast_keys_img->setEnabled(switch_windows_checkBox->isChecked());
	if(switch_windows_checkBox->isChecked())
		fast_keys_img->setEnabled(1);

	this->apply_elanshm.SHM_switch_windows_checkBox = switch_windows_checkBox->isChecked();
	#if debug_SHM_switch_windows_checkBox
		cout << "this->apply_elanshm.SHM_switch_windows_checkBox =" << this->apply_elanshm.SHM_switch_windows_checkBox << endl;
	#endif
}

/*========================page PalmTracking====================================*/

void	QElantouchPad::slot_palmtracking_checkBox()
{
	palmtracking_sensitivity_labe->setEnabled(palmtracking_checkBox->isChecked());
	palmtracking_slider->setEnabled(palmtracking_checkBox->isChecked());
	palmtracking_img->setEnabled(palmtracking_checkBox->isChecked());

	this->apply_elanshm.SHM_palmtracking_checkBox = palmtracking_checkBox->isChecked();
	#if debug_SHM_palmtracking_checkBox
		cout << "this->apply_elanshm.SHM_palmtracking_checkBox =" << this->apply_elanshm.SHM_palmtracking_checkBox << endl;
	#endif
}

void	QElantouchPad::slot_palmtracking_slider()
{
	this->apply_elanshm.SHM_palmtracking_slider = palmtracking_slider->value();
	#if debug_SHM_palmtracking_slider
		cout << "this->apply_elanshm.SHM_palmtracking_slider =" << this->apply_elanshm.SHM_palmtracking_slider << endl;
	#endif
}

/*========================page Covergesture====================================*/

void	QElantouchPad::slot_covergesture_checkBox()
{
	covergestur_sensitivity_labe->setEnabled(covergesture_checkBox->isChecked());
	covergestur_slider->setEnabled(covergesture_checkBox->isChecked());
	covergesture_img->setEnabled(covergesture_checkBox->isChecked());
	covergesture_options_label->setEnabled(covergesture_checkBox->isChecked());
	covergesture_comboBox->setEnabled(covergesture_checkBox->isChecked() );

	this->apply_elanshm.SHM_covergesture_checkBox = covergesture_checkBox->isChecked();
	#if debug_SHM_covergesture_checkBox
		cout << "this->apply_elanshm.SHM_covergesture_checkBox =" << this->apply_elanshm.SHM_covergesture_checkBox << endl;
	#endif
}

void	QElantouchPad::slot_covergesture_slider()
{
	this->apply_elanshm.SHM_covergesture_slider = covergestur_slider->value();
	#if debug_SHM_covergesture_slider
		cout << "this->apply_elanshm.SHM_covergesture_slider =" << this->apply_elanshm.SHM_covergesture_slider << endl;
	#endif
}

void	QElantouchPad::slot_covergesture_comboBox(int index)
{
	this->apply_elanshm.SHM_covergesture_comboBox = index;
	#if debug_SHM_covergesture_comboBox
		cout << "this->apply_elanshm.SHM_covergesture_comboBox =" << this->apply_elanshm.SHM_covergesture_comboBox << endl;
	#endif

}

/*========================Push button====================================*/
void 	QElantouchPad::slot_default_pushbutton()
{
	define_elanshm_value();
	return;
}


void 	QElantouchPad::slot_yes_pushbutton()
{
	set_elanshm_value();
	system("elaclient2 -l > ~/.elanshm");
#if QtElanTrayIcon
	this->hide();
	return;
#else
	this->close();
#endif
}

void 	QElantouchPad::slot_apply_pushbutton()
{	
	set_elanshm_value();
	system("elaclient2 -l > ~/.elanshm");
	return;
}

void	QElantouchPad::slot_cancel_pushbutton()
{
	//system("rm .elanshm*");
	system("elaclient2 -l > ~/.elanshm");
#if QtElanTrayIcon
	this->hide();
	return;
#else
	this->close();
#endif
}

#if QtElanTrayIcon
void	QElantouchPad::slot_iconActivated(QSystemTrayIcon::ActivationReason reason)
{
	switch(reason){
		case QSystemTrayIcon::Trigger:
			this->setWindowFlags(Qt::Dialog);
			stackedWidget->setCurrentIndex(0);
			menu_listWidget->setCurrentRow(0);
			menu_listWidget_2->setCurrentRow(0);
			menu_listWidget_3->setCurrentRow(0);
			menu_listWidget_4->setCurrentRow(0);			
			menu_listWidget_5->setCurrentRow(0);	
			this->showNormal();
			break;
		default:
			break;
	}
		
}


void	QElantouchPad::slot_iconPopMenu()
{
		
			this->setWindowFlags(Qt::Dialog);
			stackedWidget->setCurrentIndex(0);
			menu_listWidget->setCurrentRow(0);
			menu_listWidget_2->setCurrentRow(0);
			menu_listWidget_3->setCurrentRow(0);
			menu_listWidget_4->setCurrentRow(0);			
			menu_listWidget_5->setCurrentRow(0);			
			this->showNormal();			
}
#endif
/*======================sub function====================================*/
void	QElantouchPad::define_elanshm_value()
{

	/*page General*/
	this->apply_elanshm.SHM_touch_checkBox = 0;
	this->apply_elanshm.SHM_maxspeed_slider = 0.5; 

	/*page Button*/
	this->apply_elanshm.SHM_button_checkBox = 1;
	this->apply_elanshm.SHM_button_left_comboBox = 0;
	this->apply_elanshm.SHM_button_middle_comboBox = 2;
	this->apply_elanshm.SHM_button_right_comboBox = 1;
	
	/*page Tapping*/
	this->apply_elanshm.SHM_tapping_checkBox = 1;
	this->apply_elanshm.SHM_two_FT_comboBox = 7;
	this->apply_elanshm.SHM_three_FT_comboBox = 7;
	this->apply_elanshm.SHM_disable_when_key_checkBox = 1;
	this->apply_elanshm.SHM_tapping_delay_comboBox = 15;
	this->apply_elanshm.SHM_cursor_delay_comboBox = 4;
	this->apply_elanshm.SHM_cover_delay_comboBox = 4;
	this->apply_elanshm.SHM_gesture_delay_comboBox = 15;
	this->apply_elanshm.SHM_palm_delay_comboBox = 10;

	/*page Drag*/
	this->apply_elanshm.SHM_drag_checkBox = 1;
	this->apply_elanshm.SHM_lift_release_radioButton =1;
	this->apply_elanshm.SHM_tap_again_radioButton = 0;
	this->apply_elanshm.SHM_tap_release_radioButton = 0;
	this->apply_elanshm.SHM_drag_slider = 1.5;

	/*page Edge Scrolling*/
	this->apply_elanshm.SHM_edge_v_scroll_checkBox = 0;
	this->apply_elanshm.SHM_edge_h_scroll_checkBox = 0;
	this->apply_elanshm.SHM_edge_scroll_speed_slider = 5;
	this->apply_elanshm.SHM_edge_scroll_area_slider = 1;

	/*page Scrolling*/
	this->apply_elanshm.SHM_vertical_scrolling_checkBox = 1;	
	this->apply_elanshm.SHM_horizontal_scrolling_checkBox = 1;
	this->apply_elanshm.SHM_scrolling_speed_slider =4;
	this->apply_elanshm.SHM_auto_scroll_checkBox = 1;

	/*page Zoom*/
	this->apply_elanshm.SHM_zoom_checkBox = 1;
	this->apply_elanshm.SHM_zoom_out_comboBox =2;
	this->apply_elanshm.SHM_zoom_in_comboBox = 3;
	this->apply_elanshm.SHM_zoom_slider = 9;

	/*page Rotation*/
	this->apply_elanshm.SHM_rotation_checkBox = 1;
	this->apply_elanshm.SHM_clockwise_comboBox = 2;
	this->apply_elanshm.SHM_counterclosewise_comboBox = 3;
	this->apply_elanshm.SHM_rotation_slider = 7;

	/*page Swipe*/
	this->apply_elanshm.SHM_swipe_page_checkBox = 1;
	
	/*page Fast_keys*/
	this->apply_elanshm.SHM_fast_key_checkBox = 0;
	this->apply_elanshm.SHM_my_home_file_checkBox = 0;
	this->apply_elanshm.SHM_switch_windows_checkBox = 0;

	/*page PalmTracking*/
	this->apply_elanshm.SHM_palmtracking_checkBox = 1;
	this->apply_elanshm.SHM_palmtracking_slider = 4;

	/*page Covergesture*/
	this->apply_elanshm.SHM_covergesture_checkBox = 1;
	this->apply_elanshm.SHM_covergesture_slider = 11;
	this->apply_elanshm.SHM_covergesture_comboBox = 17;

	/*======================圖型初始===========================================================*/

	/*page Button*/
	button_checkBox->setChecked(this->apply_elanshm.SHM_button_checkBox);
	button_left_comboBox->setCurrentIndex(this->apply_elanshm.SHM_button_left_comboBox);
	button_middle_comboBox->setCurrentIndex(this->apply_elanshm.SHM_button_middle_comboBox);
	button_right_comboBox->setCurrentIndex(this->apply_elanshm.SHM_button_right_comboBox);

	button_left_label->setEnabled(button_checkBox->isChecked() );
	button_middle_label->setEnabled(button_checkBox->isChecked() );
	button_right_label->setEnabled(button_checkBox->isChecked() );

	button_left_img->setEnabled(button_checkBox->isChecked() );
	button_middle_img->setEnabled(button_checkBox->isChecked() );
	button_right_img->setEnabled(button_checkBox->isChecked() );

	button_left_comboBox->setEnabled(button_checkBox->isChecked() );
	button_middle_comboBox->setEnabled(button_checkBox->isChecked() );
	button_right_comboBox->setEnabled(button_checkBox->isChecked() );

	button_img->setEnabled(button_checkBox->isChecked() );

	/*page Tapping*/
	tapping_checkBox->setChecked(this->apply_elanshm.SHM_tapping_checkBox);
	two_finger_comboBox->setCurrentIndex(this->apply_elanshm.SHM_two_FT_comboBox);
	three_finger_comboBox->setCurrentIndex(this->apply_elanshm.SHM_three_FT_comboBox);
	button_checkBox->setChecked(this->apply_elanshm.SHM_button_checkBox);
	button_left_comboBox->setCurrentIndex(this->apply_elanshm.SHM_button_left_comboBox);
	button_middle_comboBox->setCurrentIndex(this->apply_elanshm.SHM_button_middle_comboBox);
	button_right_comboBox->setCurrentIndex(this->apply_elanshm.SHM_button_right_comboBox);

	button_left_label->setEnabled(button_checkBox->isChecked() );
	button_middle_label->setEnabled(button_checkBox->isChecked() );
	button_right_label->setEnabled(button_checkBox->isChecked() );

	button_left_img->setEnabled(button_checkBox->isChecked() );
	button_middle_img->setEnabled(button_checkBox->isChecked() );
	button_right_img->setEnabled(button_checkBox->isChecked() );

	button_left_comboBox->setEnabled(button_checkBox->isChecked() );
	button_middle_comboBox->setEnabled(button_checkBox->isChecked() );
	button_right_comboBox->setEnabled(button_checkBox->isChecked() );

	button_img->setEnabled(button_checkBox->isChecked() );
	key_when_type_checkBox->setChecked(this->apply_elanshm.SHM_disable_when_key_checkBox);

	tapping_delay_comboBox->setCurrentIndex(this->apply_elanshm.SHM_tapping_delay_comboBox);
	cursor_delay_comboBox->setCurrentIndex(this->apply_elanshm.SHM_cursor_delay_comboBox);
	cover_delay_comboBox->setCurrentIndex(this->apply_elanshm.SHM_cover_delay_comboBox);
	gesture_delay_comboBox->setCurrentIndex(this->apply_elanshm.SHM_gesture_delay_comboBox);
	palm_delay_comboBox->setCurrentIndex(this->apply_elanshm.SHM_palm_delay_comboBox);

	one_finger_label->setEnabled(tapping_checkBox->isChecked());	
	two_finger_label->setEnabled(tapping_checkBox->isChecked());	
	three_finger_label->setEnabled(tapping_checkBox->isChecked());
	

	one_finger_img->setEnabled(tapping_checkBox->isChecked());
	two_finger_img->setEnabled(tapping_checkBox->isChecked());
	three_fihger_img->setEnabled(tapping_checkBox->isChecked());

	Tapping_label->setEnabled(tapping_checkBox->isChecked());
	two_finger_comboBox->setEnabled(tapping_checkBox->isChecked());
	three_finger_comboBox->setEnabled(tapping_checkBox->isChecked());

	key_when_type_checkBox->setEnabled(tapping_checkBox->isChecked());
	if(key_when_type_checkBox->isChecked())
	{
		tapping_delay_label->setEnabled(key_when_type_checkBox->isChecked());
		cursor_delay_label->setEnabled(key_when_type_checkBox->isChecked());
		cover_delay_label->setEnabled(key_when_type_checkBox->isChecked());
		gesture_delay_label->setEnabled(key_when_type_checkBox->isChecked());
		palm_delay_label->setEnabled(key_when_type_checkBox->isChecked());

		tapping_delay_comboBox->setEnabled(key_when_type_checkBox->isChecked());
		cursor_delay_comboBox->setEnabled(key_when_type_checkBox->isChecked());
		cover_delay_comboBox->setEnabled(key_when_type_checkBox->isChecked());
		gesture_delay_comboBox->setEnabled(key_when_type_checkBox->isChecked());
		palm_delay_comboBox->setEnabled(key_when_type_checkBox->isChecked());
		
	}
	else
	{
		tapping_delay_label->setEnabled(0);
		cursor_delay_label->setEnabled(0);
		cover_delay_label->setEnabled(0);
		gesture_delay_label->setEnabled(0);
		palm_delay_comboBox->setEnabled(0);

		tapping_delay_comboBox->setEnabled(0);
		cursor_delay_comboBox->setEnabled(0);
		cover_delay_comboBox->setEnabled(0);
		gesture_delay_comboBox->setEnabled(0);
		palm_delay_comboBox->setEnabled(0);
	}

	tapping_img->setEnabled(tapping_checkBox->isChecked() );

	/*page Drag*/
	drag_checkBox->setChecked(this->apply_elanshm.SHM_drag_checkBox);
	
	lift_release_radioButton->setEnabled(this->apply_elanshm.SHM_drag_checkBox);
	lift_release_radioButton->setChecked(this->apply_elanshm.SHM_lift_release_radioButton);
	
	tap_again_radioButton->setEnabled(this->apply_elanshm.SHM_drag_checkBox);
	tap_again_radioButton->setChecked(this->apply_elanshm.SHM_tap_again_radioButton);
	
	tap_release_radioButton->setEnabled(this->apply_elanshm.SHM_drag_checkBox);
	tap_release_radioButton->setChecked(this->apply_elanshm.SHM_tap_release_radioButton);

	drag_slider->setEnabled(this->apply_elanshm.SHM_drag_checkBox);
	drag_slider->setValue(this->apply_elanshm.SHM_drag_slider * 10.0);
	
	drag_img->setEnabled(this->apply_elanshm.SHM_drag_checkBox);

	/*page Edge Scrolling*/
	edge_vertical_scrolling_checkBox->setChecked(this->apply_elanshm.SHM_edge_v_scroll_checkBox);
	edge_horizontail_scrolling_checkBox->setChecked(this->apply_elanshm.SHM_edge_h_scroll_checkBox);
	edge_scrolling_speed_slider->setValue(this->apply_elanshm.SHM_edge_scroll_speed_slider);
	edge_scrolling_area_slider->setValue(this->apply_elanshm.SHM_edge_scroll_area_slider);
	edge_scroll_speed_groupBox->setEnabled(0);
	edge_scroll_area_groupBox->setEnabled(0);
	edge_scrolling_img->setEnabled(0);
	
	
	/*page Scrolling*/
//	this->auto_scroll_groupBox->hide();			//tom +
	vertical_scrolling_checkBox->setChecked(this->apply_elanshm.SHM_vertical_scrolling_checkBox);
	horizontail_scrolling_checkBox->setChecked(this->apply_elanshm.SHM_horizontal_scrolling_checkBox);
	scroll_speed_slider->setValue(this->apply_elanshm.SHM_scrolling_speed_slider);
	auto_scroll_checkBox->setChecked(this->apply_elanshm.SHM_auto_scroll_checkBox);
	
	if(!horizontail_scrolling_checkBox->isChecked()){
		scrolling_img->setEnabled(vertical_scrolling_checkBox->isChecked());
		scroll_speed_slider->setEnabled(vertical_scrolling_checkBox->isChecked());
		auto_scroll_groupBox->setEnabled(vertical_scrolling_checkBox->isChecked());
	}
	if(vertical_scrolling_checkBox->isChecked()){
		scrolling_img->setEnabled(1);	
		scroll_speed_slider->setEnabled(1);
		auto_scroll_groupBox->setEnabled(1);
	}
	

	if(!vertical_scrolling_checkBox->isChecked()){
		scrolling_img->setEnabled(vertical_scrolling_checkBox->isChecked());
		scroll_speed_slider->setEnabled(vertical_scrolling_checkBox->isChecked());
		auto_scroll_groupBox->setEnabled(vertical_scrolling_checkBox->isChecked());
	}
	if(horizontail_scrolling_checkBox->isChecked()){
		scrolling_img->setEnabled(1);
		scroll_speed_slider->setEnabled(1);
		auto_scroll_groupBox->setEnabled(1);	
		
	}
	
	/*page Zoom*/
	zoom_checkBox->setChecked(this->apply_elanshm.SHM_zoom_checkBox);
	zoom_out_comboBox->setCurrentIndex(this->apply_elanshm.SHM_zoom_out_comboBox);
	zoom_in_comboBox->setCurrentIndex(this->apply_elanshm.SHM_zoom_in_comboBox);
	zoom_slider->setValue(this->apply_elanshm.SHM_zoom_slider);
	
	shrink_label->setEnabled(zoom_checkBox->isChecked());
	expand_label->setEnabled(zoom_checkBox->isChecked());

	zoom_out_comboBox->setEnabled(zoom_checkBox->isChecked());
	zoom_in_comboBox->setEnabled(zoom_checkBox->isChecked());
	
	zoom_slider->setEnabled(zoom_checkBox->isChecked());

	zoom_img->setEnabled(zoom_checkBox->isChecked());

	/*page Rotation*/
	rotation_checkBox->setChecked(this->apply_elanshm.SHM_rotation_checkBox);
	clockwise_comboBox->setCurrentIndex(this->apply_elanshm.SHM_clockwise_comboBox);
	counterclockwise_comboBox->setCurrentIndex(this->apply_elanshm.SHM_counterclosewise_comboBox);
	rotation_slider->setValue(this->apply_elanshm.SHM_rotation_slider);

	clockwise_label->setEnabled(rotation_checkBox->isChecked());
	counterclosewise_label->setEnabled(rotation_checkBox->isChecked());

	clockwise_comboBox->setEnabled(rotation_checkBox->isChecked());
	counterclockwise_comboBox->setEnabled(rotation_checkBox->isChecked());
	
	rotation_slider->setEnabled(rotation_checkBox->isChecked());

	rotation_img->setEnabled(rotation_checkBox->isChecked());

	/*page Swipe*/
	swipe_checkBox->setChecked(this->apply_elanshm.SHM_swipe_page_checkBox);
	page_up_img->setEnabled(swipe_checkBox->isChecked());
	page_down_img->setEnabled(swipe_checkBox->isChecked());

	page_up_label->setEnabled(swipe_checkBox->isChecked());
	page_down_label->setEnabled(swipe_checkBox->isChecked());

	swipe_img->setEnabled(swipe_checkBox->isChecked());

	/*page Fast_keys*/
	fast_keys_checkBox->setChecked(this->apply_elanshm.SHM_fast_key_checkBox);
	my_home_file_checkBox->setChecked(this->apply_elanshm.SHM_my_home_file_checkBox);
	switch_windows_checkBox->setChecked(this->apply_elanshm.SHM_switch_windows_checkBox);
	my_home_file_img->setEnabled(fast_keys_checkBox->isChecked());
	switch_windows_img->setEnabled(fast_keys_checkBox->isChecked());

	my_home_file_checkBox->setEnabled(fast_keys_checkBox->isChecked());
	switch_windows_checkBox->setEnabled(fast_keys_checkBox->isChecked());

	fast_keys_img->setEnabled(fast_keys_checkBox->isChecked());

	my_home_file_img->setEnabled(my_home_file_checkBox->isChecked());
	
	switch_windows_img->setEnabled(switch_windows_checkBox->isChecked());

	/*page PalmTracking*/
	palmtracking_checkBox->setChecked(this->apply_elanshm.SHM_palmtracking_checkBox);
	palmtracking_slider->setValue(this->apply_elanshm.SHM_palmtracking_slider);

	palmtracking_sensitivity_labe->setEnabled(palmtracking_checkBox->isChecked());
	palmtracking_slider->setEnabled(palmtracking_checkBox->isChecked());
	palmtracking_img->setEnabled(palmtracking_checkBox->isChecked());

	/*page Covergesture*/
	covergesture_checkBox->setChecked(this->apply_elanshm.SHM_covergesture_checkBox);
	covergestur_slider->setValue(this->apply_elanshm.SHM_covergesture_slider);
	covergesture_comboBox->setCurrentIndex(this->apply_elanshm.SHM_covergesture_comboBox);
	covergestur_sensitivity_labe->setEnabled(covergesture_checkBox->isChecked());
	covergestur_slider->setEnabled(covergesture_checkBox->isChecked());
	covergesture_img->setEnabled(covergesture_checkBox->isChecked());
	covergesture_options_label->setEnabled(covergesture_checkBox->isChecked());
	covergesture_comboBox->setEnabled(covergesture_checkBox->isChecked() );

	/*page General*/
	touchpad_checkBox->setChecked(!this->apply_elanshm.SHM_touch_checkBox);
	max_speed_slider->setValue((this->apply_elanshm.SHM_maxspeed_slider*1000.0));

	sensitivity_label->setEnabled(touchpad_checkBox->isChecked() );
	max_speed_slider->setEnabled(touchpad_checkBox->isChecked() );
	general_img->setEnabled(touchpad_checkBox->isChecked() );

	Button_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Tapping_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Scrolling_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Zoom_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Rotation_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Swipe_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Fast_Keys_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Covergesture_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	PalmTracking_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	
	return;

	return;
}

void	QElantouchPad::cur_elanshm_value()
{
	FILE *fp0,*fp1;
	int  file_over,count=0,cmp;
	int  value;
	float value_d;
	char str[128];
	char *str1 = (char *) malloc (strlen("Parameter")*sizeof(char));
	char *str2 = (char *) malloc (strlen("settings:")*sizeof(char));
	char *str_TouchpadOff = (char *) malloc (21*sizeof(char));//TouchpadOff=
	char *str_MaxSpeed = (char *) malloc (strlen("MaxSpeed=")*sizeof(char));
	char *str_ButtonCheckBox = (char *) malloc (strlen("ButtonCheckBox=")*sizeof(char));
	char *str_ButtonLeftComboBox = (char *) malloc (strlen("ButtonLeftComboBox=")*sizeof(char));
	char *str_ButtonMiddleComboBox = (char *) malloc (strlen("ButtonMiddleComboBox=")*sizeof(char));
	char *str_ButtonRightComboBox = (char *) malloc (strlen("ButtonMiddleComboBox=")*sizeof(char));
	char *str_TappingCheckBox = (char *) malloc (strlen("TappingCheckBox=")*sizeof(char));
	char *str_TwoFTComboBox = (char *) malloc (strlen("TwoFTComboBox=")*sizeof(char));
	char *str_ThreeFTComboBox = (char *) malloc (strlen("ThreeFTComboBox=")*sizeof(char));
	char *str_DisableWhenKeyCheckBox = (char *) malloc (strlen("DisableWhenKeyCheckBox=")*sizeof(char));
	char *str_TappingDelayComboBox = (char *) malloc (strlen("TappingDelayComboBox=")*sizeof(char));
	char *str_CursorDelayComboBox = (char *) malloc (21*sizeof(char));//CursorDelayComboBox=
	char *str_CoverDelayComboBox = (char *) malloc (strlen("GestureDelayComboBox=")*sizeof(char));
	char *str_GestureDelayComboBox = (char *) malloc (strlen("GestureDelayComboBox=")*sizeof(char));
	char *str_PalmDelayComboBox = (char *) malloc (strlen("PalmtrackDelayComboBox=")*sizeof(char));
	char *str_VerticalScrollingCheckBox = (char *) malloc (strlen("VerticalScrollingCheckBox=")*sizeof(char));
	char *str_HorizontalScrollingCheckBox = (char *) malloc (30*sizeof(char));//HorizontalScrollingCheckBox=
	char *str_ScrollingSpeedSlider = (char *) malloc (strlen("ScrollingSpeedSlider=")*sizeof(char));
	char *str_AutoScrollCheckBox = (char *) malloc (strlen("AutoScrollCheckBox=")*sizeof(char));
	char *str_EdgeVscrollCheckBox = (char *) malloc (30*sizeof(char));//EdgeVscrollCheckBox=
	char *str_EdgeHscrollCheckBox = (char *) malloc (30*sizeof(char));//EdgeHscrollCheckBox=
	char *str_EdgeScrollSpeedSlider = (char *) malloc (30*sizeof(char));//EdgeScrollSpeedSlider=
	char *str_EdgeScrollAreaSlider = (char *) malloc (30*sizeof(char));//EdgeScrollAreaSlider=
	char *str_ZoomCheckBox = (char *) malloc (strlen("ZoomCheckBox=")*sizeof(char));
	char *str_ZoomOutComboBox = (char *) malloc (strlen("ZoomOutComboBox=")*sizeof(char));
	char *str_ZoomInComboBox = (char *) malloc (strlen("ZoomInComboBox=")*sizeof(char));
	char *str_ZoomSlider = (char *) malloc (strlen("ZoomSlider=")*sizeof(char));
	char *str_RotationCheckBox = (char *) malloc (strlen("RotationCheckBox=")*sizeof(char));
	char *str_ClockwiseComboBox = (char *) malloc (strlen("ClockwiseComboBox=")*sizeof(char));
	char *str_CounterclosewiseComboBox = (char *) malloc (strlen("CounterclosewiseComboBox=")*sizeof(char));
	char *str_RotationSlider = (char *) malloc (strlen("RotationSlider=")*sizeof(char));
	char *str_DragCheckBox = (char *) malloc (strlen("DragCheckBox=")*sizeof(char));
	char *str_LiftReleaseRadioButton = (char *) malloc (strlen("LiftReleaseRadioButton=")*sizeof(char));
	char *str_TapAgainRadioButton = (char *) malloc (21*sizeof(char));//TapAgainRadioButton=
	char *str_TapReleaseRadioButton = (char *) malloc(strlen("TapReleaseRadioButton=")*sizeof(char));
	char *str_DragSlider = (char *) malloc(strlen("DragSlider=")*sizeof(char));
	char *str_SwipePageCheckBox = (char *) malloc (strlen("SwipePageCheckBox=")*sizeof(char));
	char *str_FastKeyCheckBox = (char *) malloc (strlen("FastKeyCheckBox=")*sizeof(char));
	char *str_MyHomeFileCheckBox = (char *) malloc (strlen("MyHomeFileCheckBox=")*sizeof(char));
	char *str_SwitchWindowsCheckBox = (char *) malloc (strlen("SwitchWindowsCheckBox=")*sizeof(char));
	char *str_CovergestureCheckBox = (char *) malloc (strlen("CovergestureCheckBox=")*sizeof(char));
	char *str_CovergestureSlider = (char *) malloc (21*sizeof(char));//CovergestureSlider
	char *str_CovergestureComboBox = (char *) malloc (strlen("CovergestureComboBox=")*sizeof(char));
	char *str_PalmtrackingCheckBox = (char *) malloc (21*sizeof(char));//PalmtrackingCheckBox
	char *str_PalmTrackingSlider = (char *) malloc (strlen("PalmTrackingSlider=")*sizeof(char));
	char *str_NULL = NULL;
	
	strcpy(str1, "Parameter");
	strcpy(str2, "settings:");
	strcpy(str_TouchpadOff, "TouchpadOff=");
	strcpy(str_MaxSpeed, "MaxSpeed=");
	strcpy(str_ButtonCheckBox, "ButtonCheckBox=");
	strcpy(str_ButtonLeftComboBox, "ButtonLeftComboBox=");
	strcpy(str_ButtonMiddleComboBox, "ButtonMiddleComboBox=");
	strcpy(str_ButtonRightComboBox, "ButtonRightComboBox=");
	strcpy(str_TappingCheckBox, "TappingCheckBox=");
	strcpy(str_TwoFTComboBox, "TwoFTComboBox=");
	strcpy(str_ThreeFTComboBox, "ThreeFTComboBox=");
	strcpy(str_DisableWhenKeyCheckBox, "DisableWhenKeyCheckBox=");
	strcpy(str_TappingDelayComboBox, "TappingDelayComboBox=");
	strcpy(str_CursorDelayComboBox, "CursorDelayComboBox=");
	strcpy(str_CoverDelayComboBox, "CoverDelayComboBox=");
	strcpy(str_GestureDelayComboBox, "GestureDelayComboBox=");
	strcpy(str_PalmDelayComboBox, "PalmtrackDelayComboBox=");
	strcpy(str_VerticalScrollingCheckBox, "VerticalScrollingCheckBox=");
	strcpy(str_HorizontalScrollingCheckBox, "HorizontalScrollingCheckBox=");
	strcpy(str_ScrollingSpeedSlider, "ScrollingSpeedSlider=");
	strcpy(str_AutoScrollCheckBox, "AutoScrollCheckBox=");
	strcpy(str_EdgeVscrollCheckBox, "EdgeVscrollCheckBox=");
	strcpy(str_EdgeHscrollCheckBox, "EdgeHscrollCheckBox=");
	strcpy(str_EdgeScrollSpeedSlider, "EdgeScrollSpeedSlider=");
	strcpy(str_EdgeScrollAreaSlider, "EdgeScrollAreaSlider=");
	strcpy(str_ZoomCheckBox, "ZoomCheckBox=");
	strcpy(str_ZoomOutComboBox, "ZoomOutComboBox=");
	strcpy(str_ZoomInComboBox, "ZoomInComboBox=");
	strcpy(str_ZoomSlider, "ZoomSlider=");
	strcpy(str_RotationCheckBox, "RotationCheckBox=");
	strcpy(str_ClockwiseComboBox, "ClockwiseComboBox=");
	strcpy(str_CounterclosewiseComboBox, "CounterclosewiseComboBox=");
	strcpy(str_RotationSlider, "RotationSlider=");
	strcpy(str_DragCheckBox,"DragCheckBox=");
	strcpy(str_LiftReleaseRadioButton,"LiftReleaseRadioButton=");
	strcpy(str_TapAgainRadioButton,"TapAgainRadioButton=");
	strcpy(str_TapReleaseRadioButton,"TapReleaseRadioButton=");
	strcpy(str_DragSlider,"DragSlider=");
	strcpy(str_SwipePageCheckBox, "SwipePageCheckBox=");
	strcpy(str_FastKeyCheckBox, "FastKeyCheckBox=");
	strcpy(str_MyHomeFileCheckBox, "MyHomeFileCheckBox=");
	strcpy(str_SwitchWindowsCheckBox, "SwitchWindowsCheckBox=");
	strcpy(str_CovergestureCheckBox, "CovergestureCheckBox=");
	strcpy(str_CovergestureSlider, "CovergestureSlider=");
	strcpy(str_CovergestureComboBox, "CovergestureComboBox=");
	strcpy(str_PalmtrackingCheckBox, "PalmtrackingCheckBox=");
	strcpy(str_PalmTrackingSlider, "PalmTrackingSlider=");
#if 1
	

one_again:
	
	system("cp ~/.elanshm ./");	
	fp0 = fopen(".elanshm","r");

	if(fp0){		
		fp1 = fopen(".elanshm_parameter","w+");		
	}

	if(fp0 == 0)
	{
		
		count++;
		if(count>=2)
			exit(1);		
		system("elaclient2 -l > ~/.elanshm");
		goto one_again;
	}
	else 
	{
		count=0;
		do
		{
			file_over=fscanf(fp0,"%s",str);
			cmp=strcmp(str,str1);
			if(cmp != 0)
			{
			   cmp=strcmp(str,str2);
			}
			
			if((cmp != 0)&& (file_over!= -1))
			{
				fprintf(fp1,"%s",str);
				count++;
				if(count==3)
				{
				  fprintf(fp1,"\n");
				  count=0;
				}
			}
		}while(file_over != -1);
	}
	
	
	fclose(fp0);
	fclose(fp1);

	fp0 = fopen(".elanshm_parameter","r");
	

	if(fp0 == NULL)
	{
		fclose(fp0);
		return;
	}else{
		do{
			file_over=fscanf(fp0,"%s",str);
			
			/*page General*/
			str_NULL = strstr(str,str_TouchpadOff);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_TouchpadOff),"%d",&value);
				this->cur_elanshm.SHM_touch_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_touch
					cout << "TouchpadOff=" << this->cur_elanshm.SHM_touch_checkBox << endl;
				#endif 
			}
			
			str_NULL = strstr(str,str_MaxSpeed);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_MaxSpeed),"%f",&value_d);
				this->cur_elanshm.SHM_maxspeed_slider = value_d;
				str_NULL=NULL;
				#if debug_SHM_maxspeed
					cout << "MaxSpeed=" << this->cur_elanshm.SHM_maxspeed_slider << endl;
				#endif 
			}

			/*page Button*/
			str_NULL = strstr(str,str_ButtonCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ButtonCheckBox),"%d",&value);
				this->cur_elanshm.SHM_button_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_button_checkBox
					cout << "ButtonCheckBox="<< this->cur_elanshm.SHM_button_checkBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_ButtonLeftComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ButtonLeftComboBox),"%d",&value);
				this->cur_elanshm.SHM_button_left_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_button_left_comboBox
					cout << "ButtonLeftComboBox=" << this->cur_elanshm.SHM_button_left_comboBox << endl;
				#endif 
			}
	
			str_NULL = strstr(str,str_ButtonMiddleComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ButtonMiddleComboBox),"%d",&value);
				this->cur_elanshm.SHM_button_middle_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_button_middle_comboBox
					cout << "ButtonMiddleComboBox=" << this->cur_elanshm.SHM_button_middle_comboBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_ButtonRightComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ButtonRightComboBox),"%d",&value);
				this->cur_elanshm.SHM_button_right_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_button_right_comboBox
					cout << "ButtonRightComboBox=" << this->cur_elanshm.SHM_button_right_comboBox << endl;
				#endif 
			}

			/*page Tapping*/
			str_NULL = strstr(str,str_TappingCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_TappingCheckBox),"%d",&value);
				this->cur_elanshm.SHM_tapping_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_tapping_checkBox
					cout << "TappingCheckBox=" << this->cur_elanshm.SHM_tapping_checkBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_TwoFTComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_TwoFTComboBox),"%d",&value);
				this->cur_elanshm.SHM_two_FT_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_two_FT_comboBox
					cout << "TwoFTComboBox=" << this->cur_elanshm.SHM_two_FT_comboBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_ThreeFTComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ThreeFTComboBox),"%d",&value);
				this->cur_elanshm.SHM_three_FT_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_three_FT_comboBox
					cout << "ThreeFTComboBox=" << this->cur_elanshm.SHM_three_FT_comboBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_DisableWhenKeyCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_DisableWhenKeyCheckBox),"%d",&value);
				this->cur_elanshm.SHM_disable_when_key_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_disable_when_key_checkBox
					cout << "DisableWhenKeyCheckBox=" << this->cur_elanshm.SHM_disable_when_key_checkBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_TappingDelayComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_TappingDelayComboBox),"%d",&value);
				this->cur_elanshm.SHM_tapping_delay_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_tapping_delay_comboBox
					cout << "TappingDelayComboBox=" << this->cur_elanshm.SHM_tapping_delay_comboBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_CursorDelayComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_CursorDelayComboBox),"%d",&value);
				this->cur_elanshm.SHM_cursor_delay_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_cursor_delay_comboBox
					cout << "CursorDelayComboBox=" << this->cur_elanshm.SHM_cursor_delay_comboBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_CoverDelayComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_CoverDelayComboBox),"%d",&value);
				this->cur_elanshm.SHM_cover_delay_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_cover_delay_comboBox
					cout << "CoverDelayComboBox=" << this->cur_elanshm.SHM_cover_delay_comboBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_GestureDelayComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_GestureDelayComboBox),"%d",&value);
				this->cur_elanshm.SHM_gesture_delay_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_gesture_delay_comboBox
					cout << "GestureDelayComboBox=" << this->cur_elanshm.SHM_gesture_delay_comboBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_PalmDelayComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_PalmDelayComboBox),"%d",&value);
				this->cur_elanshm.SHM_palm_delay_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_palm_delay_comboBox
					cout << "PalmtrackDelayComboBox=" << this->cur_elanshm.SHM_palm_delay_comboBox << endl;
				#endif 
			}

			/*page Drag*/
			str_NULL = strstr(str,str_DragCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_DragCheckBox),"%d",&value);
				this->cur_elanshm.SHM_drag_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_drag_checkBox
					cout << "DragCheckBox=" << this->cur_elanshm.SHM_drag_checkBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_LiftReleaseRadioButton);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_LiftReleaseRadioButton),"%d",&value);
				this->cur_elanshm.SHM_lift_release_radioButton = value;
				str_NULL=NULL;
				#if debug_SHM_lift_release_radioButton
					cout << "LiftReleaseRadioButton=" << this->cur_elanshm.SHM_tap_again_radioButton << endl;
				#endif 
			}

			str_NULL = strstr(str,str_TapAgainRadioButton);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_TapAgainRadioButton),"%d",&value);
				this->cur_elanshm.SHM_tap_again_radioButton = value;
				str_NULL=NULL;
				#if debug_SHM_tap_again_radioButton
					cout << "TapAgainRadioButton=" << this->cur_elanshm.SHM_tap_again_radioButton << endl;
				#endif 
			}
	
			str_NULL = strstr(str,str_TapReleaseRadioButton);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_TapReleaseRadioButton),"%d",&value);
				this->cur_elanshm.SHM_tap_release_radioButton = value;
				str_NULL=NULL;
				#if debug_SHM_tap_release_radioButton
					cout << "TapReleaseRadioButton=" << this->cur_elanshm.SHM_tap_release_radioButton << endl;
				#endif 
			}

			str_NULL = strstr(str,str_DragSlider);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_DragSlider),"%f",&value_d);
				this->cur_elanshm.SHM_drag_slider = value_d;
				str_NULL=NULL;
				#if debug_SHM_drag_slider
					cout << "DragSlider=" << this->cur_elanshm.SHM_drag_slider << endl;
				#endif 
			}

			/*page Edge Scrolling*/
			str_NULL = strstr(str,str_EdgeVscrollCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_EdgeVscrollCheckBox),"%d",&value);
				this->cur_elanshm.SHM_edge_v_scroll_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_edge_v_scroll_checkBox
					cout << "EdgeVscrollCheckBox=" << this->cur_elanshm.SHM_edge_v_scroll_checkBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_EdgeHscrollCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_EdgeHscrollCheckBox),"%d",&value);
				this->cur_elanshm.SHM_edge_h_scroll_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_edge_h_scroll_checkBox
					cout << "EdgeHscrollCheckBox=" << this->cur_elanshm.SHM_edge_h_scroll_checkBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_EdgeScrollSpeedSlider);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_EdgeScrollSpeedSlider),"%d",&value);
				this->cur_elanshm.SHM_edge_scroll_speed_slider = value;
				str_NULL=NULL;
				#if debug_SHM_edge_scrolling_speed_slider
					cout << "EdgeScrollSpeedSlider=" << this->cur_elanshm.SHM_edge_scroll_speed_slider << endl;
				#endif 
			}

			str_NULL = strstr(str,str_EdgeScrollAreaSlider);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_EdgeScrollAreaSlider),"%d",&value);
				this->cur_elanshm.SHM_edge_scroll_area_slider = value;
				str_NULL=NULL;
				#if debug_SHM_edge_scrolling_area_slider
					cout << "EdgeScrollAreaSlider=" << this->cur_elanshm.SHM_edge_scroll_area_slider << endl;
				#endif 
			}


			/*page Scrolling*/
			str_NULL = strstr(str,str_VerticalScrollingCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_VerticalScrollingCheckBox),"%d",&value);
				this->cur_elanshm.SHM_vertical_scrolling_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_vertical_scrolling_checkBox
					cout << "VerticalScrollingCheckBox=" << this->cur_elanshm.SHM_vertical_scrolling_checkBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_HorizontalScrollingCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_HorizontalScrollingCheckBox),"%d",&value);
				this->cur_elanshm.SHM_horizontal_scrolling_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_horizontal_scrolling_checkBox
					cout << "HorizontalScrollingCheckBox=" << this->cur_elanshm.SHM_horizontal_scrolling_checkBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_ScrollingSpeedSlider);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ScrollingSpeedSlider),"%d",&value);
				this->cur_elanshm.SHM_scrolling_speed_slider = value;
				str_NULL=NULL;
				#if debug_SHM_scrolling_speed_slider
					cout << "ScrollingSpeedSlider=" << this->cur_elanshm.SHM_scrolling_speed_slider << endl;
				#endif 
			}

			str_NULL = strstr(str,str_AutoScrollCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_AutoScrollCheckBox),"%d",&value);
				this->cur_elanshm.SHM_auto_scroll_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_auto_scroll_checkBox
					cout << "AutoScrollCheckBox=" << this->cur_elanshm.SHM_auto_scroll_checkBox << endl;
				#endif 
			}

			/*page Zoom*/
			str_NULL = strstr(str,str_ZoomCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ZoomCheckBox),"%d",&value);
				this->cur_elanshm.SHM_zoom_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_zoom_checkBox
					cout << "ZoomCheckBox=" << this->cur_elanshm.SHM_zoom_checkBox << endl;
				#endif 
			}
			
			str_NULL = strstr(str,str_ZoomOutComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ZoomOutComboBox),"%d",&value);
				this->cur_elanshm.SHM_zoom_out_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_zoom_out_comboBox
					cout << "ZoomOutComboBox=" << this->cur_elanshm.SHM_zoom_out_comboBox << endl;
				#endif 
			}
			
			str_NULL = strstr(str,str_ZoomInComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ZoomInComboBox),"%d",&value);
				this->cur_elanshm.SHM_zoom_in_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_zoom_in_comboBox
					cout << "ZoomInComboBox=" << this->cur_elanshm.SHM_zoom_in_comboBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_ZoomSlider);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ZoomSlider),"%d",&value);
				this->cur_elanshm.SHM_zoom_slider = value;
				str_NULL=NULL;
				#if debug_SHM_zoom_slider
					cout << "ZoomSlider=" << this->cur_elanshm.SHM_zoom_slider << endl;
				#endif 
			}

			/*page Rotation*/
			str_NULL = strstr(str,str_RotationCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_RotationCheckBox),"%d",&value);
				this->cur_elanshm.SHM_rotation_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_rotation_checkBox
					cout << "RotationCheckBox=" << this->cur_elanshm.SHM_rotation_checkBox << endl;
				#endif 
			}

			
			str_NULL = strstr(str,str_ClockwiseComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_ClockwiseComboBox),"%d",&value);
				this->cur_elanshm.SHM_clockwise_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_clockwise_comboBox
					cout << "ClockwiseComboBox=" << this->cur_elanshm.SHM_clockwise_comboBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_CounterclosewiseComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_CounterclosewiseComboBox),"%d",&value);
				this->cur_elanshm.SHM_counterclosewise_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_counterclosewise_comboBox
					cout << "CounterclosewiseComboBox=" << this->cur_elanshm.SHM_counterclosewise_comboBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_RotationSlider);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_RotationSlider),"%d",&value);
				this->cur_elanshm.SHM_rotation_slider = value;
				str_NULL=NULL;
				#if debug_SHM_rotation_slider
					cout << "CounterclosewiseComboBox=" << this->cur_elanshm.SHM_rotation_slider << endl;
				#endif 
			}
			
			/*page Swipe*/
			str_NULL = strstr(str,str_SwipePageCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_SwipePageCheckBox),"%d",&value);
				this->cur_elanshm.SHM_swipe_page_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_swipe_page_checkBox
					cout << "SwipePageCheckBox=" << this->cur_elanshm.SHM_swipe_page_checkBox << endl;
				#endif 
			}

			/*page Fast_keys*/
			str_NULL = strstr(str,str_FastKeyCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_FastKeyCheckBox),"%d",&value);
				this->cur_elanshm.SHM_fast_key_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_fast_key_checkBox
					cout << "FastKeyCheckBox=" << this->cur_elanshm.SHM_fast_key_checkBox << endl;
				#endif 
			}
			
			str_NULL = strstr(str,str_MyHomeFileCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_MyHomeFileCheckBox),"%d",&value);
				this->cur_elanshm.SHM_my_home_file_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_my_home_file_checkBox
					cout << "MyHomeFileCheckBox=" << this->cur_elanshm.SHM_my_home_file_checkBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_SwitchWindowsCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_SwitchWindowsCheckBox),"%d",&value);
				this->cur_elanshm.SHM_switch_windows_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_switch_windows_checkBox
					cout << "SwitchWindowsCheckBox=" << this->cur_elanshm.SHM_switch_windows_checkBox << endl;
				#endif 
			}

			/*page Palm*/
			str_NULL = strstr(str,str_PalmtrackingCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_PalmtrackingCheckBox),"%d",&value);
				this->cur_elanshm.SHM_palmtracking_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_palmtracking_checkBox
					cout << "PalmtrackingCheckBox=" << this->cur_elanshm.SHM_palmtracking_checkBox << endl;
				#endif 
			}
		
			str_NULL = strstr(str,str_PalmTrackingSlider);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_PalmTrackingSlider),"%d",&value);
				this->cur_elanshm.SHM_palmtracking_slider = value;
				str_NULL=NULL;
				#if debug_SHM_palmtracking_slider
					cout << "PalmTrackingSlider=" << this->cur_elanshm.SHM_palmtracking_slider << endl;
				#endif 
			}

			/*page Covergesture*/
			str_NULL = strstr(str,str_CovergestureCheckBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_CovergestureCheckBox),"%d",&value);
				this->cur_elanshm.SHM_covergesture_checkBox = value;
				str_NULL=NULL;
				#if debug_SHM_covergesture_checkBox
					cout << "CovergestureCheckBox=" << this->cur_elanshm.SHM_covergesture_checkBox << endl;
				#endif 
			}

			str_NULL = strstr(str,str_CovergestureSlider);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_CovergestureSlider),"%d",&value);
				this->cur_elanshm.SHM_covergesture_slider = value;
				str_NULL=NULL;
				#if debug_SHM_covergesture_slider
					cout << "CovergestureSlider=" << this->cur_elanshm.SHM_covergesture_slider << endl;
				#endif 
			}
			
			str_NULL = strstr(str,str_CovergestureComboBox);
			if(str_NULL)
			{
				sscanf(str_NULL+strlen(str_CovergestureComboBox),"%d",&value);
				this->cur_elanshm.SHM_covergesture_comboBox = value;
				str_NULL=NULL;
				#if debug_SHM_covergesture_comboBox
					cout << "CovergestureComboBox=" << this->cur_elanshm.SHM_covergesture_comboBox << endl;
				#endif 
			}
		}while(file_over != -1);
	}
	

	fclose(fp0);
#endif	

#if 0
	free(str1);
	cout<<"steup1-1"<<endl;
	free(str2);
	cout<<"steup1-2"<<endl;
	free(str_TouchpadOff);
	cout<<"steup1-str_TouchpadOff"<<endl;
	free(str_MaxSpeed);
	cout<<"steup1-str_MaxSpeed"<<endl;
	free(str_ButtonCheckBox);
	cout<<"steup1-str_ButtonCheckBox"<<endl;	
	free(str_ButtonLeftComboBox);
	cout<<"steup1-str_ButtonLeftComboBox"<<endl;
	free(str_ButtonMiddleComboBox);
	cout<<"steup1-str_ButtonMiddleComboBox"<<endl;
	free(str_ButtonRightComboBox);
	cout<<"steup1-str_ButtonRightComboBox"<<endl;	
	free(str_TappingCheckBox);
	cout<<"steup1-str_TappingCheckBox"<<endl;
	free(str_TwoFTComboBox);
	cout<<"steup1-str_TwoFTComboBox"<<endl;
	free(str_ThreeFTComboBox);
	cout<<"steup1-str_ThreeFTComboBox"<<endl;
	free(str_DisableWhenKeyCheckBox);
	cout<<"steup1-str_DisableWhenKeyCheckBox"<<endl;
	free(str_TappingDelayComboBox);
	cout<<"steup1-str_TappingDelayComboBox"<<endl;
	free(str_CursorDelayComboBox);
	cout<<"steup1-str_CursorDelayComboBox"<<endl;
	free(str_CoverDelayComboBox);
	cout<<"steup1-str_CoverDelayComboBox"<<endl;
	free(str_GestureDelayComboBox);
	cout<<"steup1-str_GestureDelayComboBox"<<endl;
	free(str_PalmDelayComBox);
	cout<<"steup1-str_PalmDelayComboBox"<<endl;
	free(str_VerticalScrollingCheckBox);
	cout<<"steup1-str_VerticalScrollingCheckBox"<<endl;
	free(str_HorizontalScrollingCheckBox);
	cout<<"steup1-str_HorizontalScrollingCheckBox"<<endl;
	free(str_ScrollingSpeedSlider);
	cout<<"steup1-str_ScrollingSpeedSlider"<<endl;
	free(str_AutoScrollCheckBox);
	cout<<"steup1-str_AutoScrollCheckBox"<<endl;	
	free(str_ZoomCheckBox);
	cout<<"steup1-str_ZoomCheckBox8"<<endl;
	free(str_ZoomOutComboBox);
	cout<<"steup1-str_ZoomOutComboBox"<<endl;
	free(str_ZoomInComboBox);
	cout<<"steup1-str_ZoomInComboBox"<<endl;
	free(str_ZoomSlider);
	cout<<"steup1-str_ZoomSlider"<<endl;
	free(str_RotationCheckBox);
	cout<<"steup1-str_RotationCheckBox"<<endl;
	free(str_ClockwiseComboBox);
	cout<<"steup1-str_ClockwiseComboBox"<<endl;
	free(str_CounterclosewiseComboBox);
	cout<<"steup1-str_CounterclosewiseComboBox"<<endl;
	free(str_RotationSlider);
	cout<<"steup1-str_RotationSlider"<<endl;
	free(str_DragCheckBox);
	cout<<"steup1-str_DragCheckBox"<<endl;
	free(str_LiftReleaseRadioButton);
	cout<<"steup1-str_LiftReleaseRadioButton"<<endl;
	free(str_TapAgainRadioButton);
	cout<<"steup1-str_TapAgainRadioButton"<<endl;
	free(str_TapReleaseRadioButton);
	cout<<"steup1-str_TapReleaseRadioButton"<<endl;
	free(str_DragSlider);
	cout<<"steup1-str_DragSlider"<<endl;
	free(str_SwipePageCheckBox);
	cout<<"steup1-str_SwipePageCheckBox"<<endl;
	free(str_FastKeyCheckBox);
	cout<<"steup1-str_FastKeyCheckBox"<<endl;
	free(str_MyHomeFileCheckBox);
	cout<<"steup1-str_MyHomeFileCheckBox"<<endl;
	free(str_SwitchWindowsCheckBox);
	cout<<"steup1-str_SwitchWindowsCheckBox"<<endl;
	free(str_CovergestureCheckBox);
	cout<<"steup1-str_CovergestureCheckBox"<<endl;
	free(str_CovergestureSlider);
	cout<<"steup1-str_CovergestureSlider"<<endl;	
	free(str_CovergestureComboBox);
	cout<<"steup1-str_CovergestureComboBox"<<endl;	
	free(str_PalmtrackingCheckBox);
	cout<<"steup1-str_PalmtrackingCheckBox"<<endl;
	free(str_PalmTrackingSlider);
	cout<<"steup1-str_PalmTrackingSlider"<<endl;
#else
	free(str1);
	free(str2);
	free(str_TouchpadOff);
	free(str_MaxSpeed);
	free(str_ButtonCheckBox);	
	free(str_ButtonLeftComboBox);
	free(str_ButtonMiddleComboBox);
	free(str_ButtonRightComboBox);
	free(str_TappingCheckBox);
	free(str_TwoFTComboBox);
	free(str_ThreeFTComboBox);
	free(str_DisableWhenKeyCheckBox);
	free(str_TappingDelayComboBox);
	free(str_CursorDelayComboBox);
	free(str_CoverDelayComboBox);
	free(str_GestureDelayComboBox);
	free(str_PalmDelayComboBox);
	free(str_VerticalScrollingCheckBox);
	free(str_HorizontalScrollingCheckBox);
	free(str_ScrollingSpeedSlider);
	free(str_AutoScrollCheckBox);
	free(str_EdgeVscrollCheckBox);
	free(str_EdgeHscrollCheckBox);
	free(str_EdgeScrollSpeedSlider);
	free(str_EdgeScrollAreaSlider);
	free(str_ZoomCheckBox);
	free(str_ZoomOutComboBox);
	free(str_ZoomInComboBox);
	free(str_ZoomSlider);
	free(str_RotationCheckBox);
	free(str_ClockwiseComboBox);
	free(str_CounterclosewiseComboBox);
	free(str_RotationSlider);
	free(str_DragCheckBox);
	free(str_LiftReleaseRadioButton);
	free(str_TapAgainRadioButton);
	free(str_TapReleaseRadioButton);
	free(str_DragSlider);
	free(str_SwipePageCheckBox);
	free(str_FastKeyCheckBox);
	free(str_MyHomeFileCheckBox);
	free(str_SwitchWindowsCheckBox);
	free(str_CovergestureCheckBox);	
	free(str_CovergestureSlider);		
	free(str_CovergestureComboBox);
	free(str_PalmtrackingCheckBox);	
	free(str_PalmTrackingSlider);
	
#endif
	return;
}

void	QElantouchPad::catch_elanshm_value()
{

	/*======================資料初始===========================================================*/
	/*page General*/
	this->apply_elanshm.SHM_touch_checkBox = this->cur_elanshm.SHM_touch_checkBox;
	this->apply_elanshm.SHM_maxspeed_slider = this->cur_elanshm.SHM_maxspeed_slider; 

	/*page Button*/
	this->apply_elanshm.SHM_button_checkBox = this->cur_elanshm.SHM_button_checkBox;
	this->apply_elanshm.SHM_button_left_comboBox = this->cur_elanshm.SHM_button_left_comboBox;
	this->apply_elanshm.SHM_button_middle_comboBox = this->cur_elanshm.SHM_button_middle_comboBox;
	this->apply_elanshm.SHM_button_right_comboBox = this->cur_elanshm.SHM_button_right_comboBox;
	
	/*page Tapping*/
	this->apply_elanshm.SHM_tapping_checkBox = this->cur_elanshm.SHM_tapping_checkBox;
	this->apply_elanshm.SHM_two_FT_comboBox = this->cur_elanshm.SHM_two_FT_comboBox;
	this->apply_elanshm.SHM_three_FT_comboBox = this->cur_elanshm.SHM_three_FT_comboBox;
	this->apply_elanshm.SHM_disable_when_key_checkBox = this->cur_elanshm.SHM_disable_when_key_checkBox;
	this->apply_elanshm.SHM_tapping_delay_comboBox = this->cur_elanshm.SHM_tapping_delay_comboBox;
	this->apply_elanshm.SHM_cursor_delay_comboBox = this->cur_elanshm.SHM_cursor_delay_comboBox;
	this->apply_elanshm.SHM_cover_delay_comboBox = this->cur_elanshm.SHM_cover_delay_comboBox;
	this->apply_elanshm.SHM_gesture_delay_comboBox = this->cur_elanshm.SHM_gesture_delay_comboBox;
	this->apply_elanshm.SHM_palm_delay_comboBox = this->cur_elanshm.SHM_gesture_delay_comboBox;

	/*page Drag*/
	this->apply_elanshm.SHM_drag_checkBox = this->cur_elanshm.SHM_drag_checkBox;
	this->apply_elanshm.SHM_lift_release_radioButton = this->cur_elanshm.SHM_lift_release_radioButton;
	this->apply_elanshm.SHM_tap_again_radioButton = this->cur_elanshm.SHM_tap_again_radioButton;
	this->apply_elanshm.SHM_tap_release_radioButton = this->cur_elanshm.SHM_tap_release_radioButton;
	this->apply_elanshm.SHM_drag_slider = this->cur_elanshm.SHM_drag_slider;

	/*page Edge Scrolling*/
	this->apply_elanshm.SHM_edge_v_scroll_checkBox = this->cur_elanshm.SHM_edge_v_scroll_checkBox;
	this->apply_elanshm.SHM_edge_h_scroll_checkBox = this->cur_elanshm.SHM_edge_h_scroll_checkBox;
	this->apply_elanshm.SHM_edge_scroll_speed_slider = this->cur_elanshm.SHM_edge_scroll_speed_slider;
	this->apply_elanshm.SHM_edge_scroll_area_slider = this->cur_elanshm.SHM_edge_scroll_area_slider;

	/*page Scrolling*/
	this->apply_elanshm.SHM_vertical_scrolling_checkBox = this->cur_elanshm.SHM_vertical_scrolling_checkBox;
	this->apply_elanshm.SHM_horizontal_scrolling_checkBox = this->cur_elanshm.SHM_horizontal_scrolling_checkBox;
	this->apply_elanshm.SHM_scrolling_speed_slider = this->cur_elanshm.SHM_scrolling_speed_slider;
	this->apply_elanshm.SHM_auto_scroll_checkBox = this->cur_elanshm.SHM_auto_scroll_checkBox;
	
	/*page Zoom*/
	this->apply_elanshm.SHM_zoom_checkBox = this->cur_elanshm.SHM_zoom_checkBox;
	this->apply_elanshm.SHM_zoom_out_comboBox = this->cur_elanshm.SHM_zoom_out_comboBox;
	this->apply_elanshm.SHM_zoom_in_comboBox = this->cur_elanshm.SHM_zoom_in_comboBox;
	this->apply_elanshm.SHM_zoom_slider = this->cur_elanshm.SHM_zoom_slider;

	/*page Rotation*/
	this->apply_elanshm.SHM_rotation_checkBox = this->cur_elanshm.SHM_rotation_checkBox;
	this->apply_elanshm.SHM_clockwise_comboBox = this->cur_elanshm.SHM_clockwise_comboBox;
	this->apply_elanshm.SHM_counterclosewise_comboBox = this->cur_elanshm.SHM_counterclosewise_comboBox;
	this->apply_elanshm.SHM_rotation_slider = this->cur_elanshm.SHM_rotation_slider;

	/*page Swipe*/
	this->apply_elanshm.SHM_swipe_page_checkBox = this->cur_elanshm.SHM_swipe_page_checkBox;
	
	/*page Fast_keys*/
	this->apply_elanshm.SHM_fast_key_checkBox = this->cur_elanshm.SHM_fast_key_checkBox;
	this->apply_elanshm.SHM_my_home_file_checkBox = this->cur_elanshm.SHM_my_home_file_checkBox;
	this->apply_elanshm.SHM_switch_windows_checkBox = this->cur_elanshm.SHM_switch_windows_checkBox;

	/*page PalmTracking*/
	this->apply_elanshm.SHM_palmtracking_checkBox = this->cur_elanshm.SHM_palmtracking_checkBox;
	this->apply_elanshm.SHM_palmtracking_slider = this->cur_elanshm.SHM_palmtracking_slider;

	/*page Covergesture*/
	this->apply_elanshm.SHM_covergesture_checkBox = this->cur_elanshm.SHM_covergesture_checkBox;
	this->apply_elanshm.SHM_covergesture_slider = this->cur_elanshm.SHM_covergesture_slider;
	this->apply_elanshm.SHM_covergesture_comboBox = this->cur_elanshm.SHM_covergesture_comboBox;

	/*======================圖型初始===========================================================*/

	/*page Button*/
	button_checkBox->setChecked(this->apply_elanshm.SHM_button_checkBox);
	button_left_comboBox->setCurrentIndex(this->apply_elanshm.SHM_button_left_comboBox);
	button_middle_comboBox->setCurrentIndex(this->apply_elanshm.SHM_button_middle_comboBox);
	button_right_comboBox->setCurrentIndex(this->apply_elanshm.SHM_button_right_comboBox);

	button_left_label->setEnabled(button_checkBox->isChecked() );
	button_middle_label->setEnabled(button_checkBox->isChecked() );
	button_right_label->setEnabled(button_checkBox->isChecked() );

	button_left_img->setEnabled(button_checkBox->isChecked() );
	button_middle_img->setEnabled(button_checkBox->isChecked() );
	button_right_img->setEnabled(button_checkBox->isChecked() );

	button_left_comboBox->setEnabled(button_checkBox->isChecked() );
	button_middle_comboBox->setEnabled(button_checkBox->isChecked() );
	button_right_comboBox->setEnabled(button_checkBox->isChecked() );

	button_img->setEnabled(button_checkBox->isChecked() );

	/*page Tapping*/
	tapping_checkBox->setChecked(this->apply_elanshm.SHM_tapping_checkBox);
	two_finger_comboBox->setCurrentIndex(this->apply_elanshm.SHM_two_FT_comboBox);
	three_finger_comboBox->setCurrentIndex(this->apply_elanshm.SHM_three_FT_comboBox);
	key_when_type_checkBox->setChecked(this->apply_elanshm.SHM_disable_when_key_checkBox);
	tapping_delay_comboBox->setCurrentIndex(this->apply_elanshm.SHM_tapping_delay_comboBox);
	cursor_delay_comboBox->setCurrentIndex(this->apply_elanshm.SHM_cursor_delay_comboBox);
	cover_delay_comboBox->setCurrentIndex(this->apply_elanshm.SHM_cover_delay_comboBox);
	gesture_delay_comboBox->setCurrentIndex(this->apply_elanshm.SHM_gesture_delay_comboBox);
	palm_delay_comboBox->setCurrentIndex(this->apply_elanshm.SHM_palm_delay_comboBox);

	one_finger_label->setEnabled(tapping_checkBox->isChecked() );	
	two_finger_label->setEnabled(tapping_checkBox->isChecked() );	
	three_finger_label->setEnabled(tapping_checkBox->isChecked() );
	

	one_finger_img->setEnabled(tapping_checkBox->isChecked() );
	two_finger_img->setEnabled(tapping_checkBox->isChecked() );
	three_fihger_img->setEnabled(tapping_checkBox->isChecked() );

	Tapping_label->setEnabled(tapping_checkBox->isChecked() );
	two_finger_comboBox->setEnabled(tapping_checkBox->isChecked() );
	three_finger_comboBox->setEnabled(tapping_checkBox->isChecked() );

	key_when_type_checkBox->setEnabled(tapping_checkBox->isChecked() );
	if(key_when_type_checkBox->isChecked() )
	{
		tapping_delay_label->setEnabled(key_when_type_checkBox->isChecked() );
		cursor_delay_label->setEnabled(key_when_type_checkBox->isChecked() );
		cover_delay_label->setEnabled(key_when_type_checkBox->isChecked() );
		gesture_delay_label->setEnabled(key_when_type_checkBox->isChecked() );
		palm_delay_label->setEnabled(key_when_type_checkBox->isChecked() );

		tapping_delay_comboBox->setEnabled(key_when_type_checkBox->isChecked() );
		cursor_delay_comboBox->setEnabled(key_when_type_checkBox->isChecked() );
		cover_delay_comboBox->setEnabled(key_when_type_checkBox->isChecked() );
		gesture_delay_comboBox->setEnabled(key_when_type_checkBox->isChecked() );
		palm_delay_comboBox->setEnabled(key_when_type_checkBox->isChecked() );	
	}
	else
	{
		tapping_delay_label->setEnabled(0);
		cursor_delay_label->setEnabled(0);
		cover_delay_label->setEnabled(0);
		gesture_delay_label->setEnabled(0);
		palm_delay_label->setEnabled(0);

		tapping_delay_comboBox->setEnabled(0);
		cursor_delay_comboBox->setEnabled(0);
		cover_delay_comboBox->setEnabled(0);
		gesture_delay_comboBox->setEnabled(0);
		palm_delay_comboBox->setEnabled(0);
	}

	tapping_img->setEnabled(tapping_checkBox->isChecked() );

	/*page Drag*/
	drag_checkBox->setChecked(this->apply_elanshm.SHM_drag_checkBox);

	lift_release_radioButton->setEnabled(this->apply_elanshm.SHM_drag_checkBox);
	lift_release_radioButton->setChecked(this->apply_elanshm.SHM_lift_release_radioButton);

	tap_again_radioButton->setEnabled(this->apply_elanshm.SHM_drag_checkBox);
	tap_again_radioButton->setChecked(this->apply_elanshm.SHM_tap_again_radioButton);
	
	tap_release_radioButton->setEnabled(this->apply_elanshm.SHM_drag_checkBox);
	tap_release_radioButton->setChecked(this->apply_elanshm.SHM_tap_release_radioButton);

	drag_slider->setEnabled(this->apply_elanshm.SHM_drag_checkBox);
	drag_slider->setValue((this->apply_elanshm.SHM_drag_slider * 10.0));

	drag_img->setEnabled(this->apply_elanshm.SHM_drag_checkBox);

	/*page Edge Scrolling*/
	edge_vertical_scrolling_checkBox->setChecked(this->apply_elanshm.SHM_edge_v_scroll_checkBox);
	edge_horizontail_scrolling_checkBox->setChecked(this->apply_elanshm.SHM_edge_h_scroll_checkBox);
	edge_scrolling_area_slider->setValue(this->apply_elanshm.SHM_edge_scroll_area_slider);
	edge_scrolling_speed_slider->setValue(this->apply_elanshm.SHM_edge_scroll_speed_slider);

	if(!edge_vertical_scrolling_checkBox->isChecked() && !edge_horizontail_scrolling_checkBox->isChecked())
	{
		edge_scroll_speed_groupBox->setEnabled(0);
		edge_scroll_area_groupBox->setEnabled(0);
		edge_scrolling_img->setEnabled(0);
	}
	else
	{
		edge_scroll_speed_groupBox->setEnabled(1);
		edge_scroll_area_groupBox->setEnabled(1);
		edge_scrolling_img->setEnabled(1);
	}

	/*page Scrolling*/
//	this->auto_scroll_groupBox->hide();			//tom +
	vertical_scrolling_checkBox->setChecked(this->apply_elanshm.SHM_vertical_scrolling_checkBox);
	horizontail_scrolling_checkBox->setChecked(this->apply_elanshm.SHM_horizontal_scrolling_checkBox);
	scroll_speed_slider->setValue(this->apply_elanshm.SHM_scrolling_speed_slider);
	auto_scroll_checkBox->setChecked(this->apply_elanshm.SHM_auto_scroll_checkBox);
	
	if(!horizontail_scrolling_checkBox->isChecked()){
		scrolling_img->setEnabled(vertical_scrolling_checkBox->isChecked());
		scroll_speed_slider->setEnabled(vertical_scrolling_checkBox->isChecked());
		auto_scroll_groupBox->setEnabled(vertical_scrolling_checkBox->isChecked());
	}
	if(vertical_scrolling_checkBox->isChecked()){
		scrolling_img->setEnabled(1);	
		scroll_speed_slider->setEnabled(1);
		auto_scroll_groupBox->setEnabled(1);
	}
	

	if(!vertical_scrolling_checkBox->isChecked()){
		scrolling_img->setEnabled(vertical_scrolling_checkBox->isChecked());
		scroll_speed_slider->setEnabled(vertical_scrolling_checkBox->isChecked());
		auto_scroll_groupBox->setEnabled(vertical_scrolling_checkBox->isChecked());
	}
	if(horizontail_scrolling_checkBox->isChecked()){
		scrolling_img->setEnabled(1);
		scroll_speed_slider->setEnabled(1);
		auto_scroll_groupBox->setEnabled(1);	
		
	}

	/*page Zoom*/
	zoom_checkBox->setChecked(this->apply_elanshm.SHM_zoom_checkBox);
	zoom_out_comboBox->setCurrentIndex(this->apply_elanshm.SHM_zoom_out_comboBox);
	zoom_in_comboBox->setCurrentIndex(this->apply_elanshm.SHM_zoom_in_comboBox);
	zoom_slider->setValue(this->apply_elanshm.SHM_zoom_slider);
	
	shrink_label->setEnabled(zoom_checkBox->isChecked());
	expand_label->setEnabled(zoom_checkBox->isChecked());

	zoom_out_comboBox->setEnabled(zoom_checkBox->isChecked());
	zoom_in_comboBox->setEnabled(zoom_checkBox->isChecked());
	
	zoom_slider->setEnabled(zoom_checkBox->isChecked());

	zoom_img->setEnabled(zoom_checkBox->isChecked());

	/*page Rotation*/
	rotation_checkBox->setChecked(this->apply_elanshm.SHM_rotation_checkBox);
	clockwise_comboBox->setCurrentIndex(this->apply_elanshm.SHM_clockwise_comboBox);
	counterclockwise_comboBox->setCurrentIndex(this->apply_elanshm.SHM_counterclosewise_comboBox);
	rotation_slider->setValue(this->apply_elanshm.SHM_rotation_slider);

	clockwise_label->setEnabled(rotation_checkBox->isChecked());
	counterclosewise_label->setEnabled(rotation_checkBox->isChecked());

	clockwise_comboBox->setEnabled(rotation_checkBox->isChecked());
	counterclockwise_comboBox->setEnabled(rotation_checkBox->isChecked());
	
	rotation_slider->setEnabled(rotation_checkBox->isChecked());

	rotation_img->setEnabled(rotation_checkBox->isChecked());

	/*page Swipe*/
	swipe_checkBox->setChecked(this->apply_elanshm.SHM_swipe_page_checkBox);
	page_up_img->setEnabled(swipe_checkBox->isChecked());
	page_down_img->setEnabled(swipe_checkBox->isChecked());

	page_up_label->setEnabled(swipe_checkBox->isChecked());
	page_down_label->setEnabled(swipe_checkBox->isChecked());

	swipe_img->setEnabled(swipe_checkBox->isChecked());

	/*page Fast_keys*/
	fast_keys_checkBox->setChecked(this->apply_elanshm.SHM_fast_key_checkBox);
	my_home_file_checkBox->setChecked(this->apply_elanshm.SHM_my_home_file_checkBox);
	switch_windows_checkBox->setChecked(this->apply_elanshm.SHM_switch_windows_checkBox);
	my_home_file_img->setEnabled(fast_keys_checkBox->isChecked());
	switch_windows_img->setEnabled(fast_keys_checkBox->isChecked());

	my_home_file_checkBox->setEnabled(fast_keys_checkBox->isChecked());
	switch_windows_checkBox->setEnabled(fast_keys_checkBox->isChecked());

	fast_keys_img->setEnabled(fast_keys_checkBox->isChecked());

	my_home_file_img->setEnabled(my_home_file_checkBox->isChecked());
	
	switch_windows_img->setEnabled(switch_windows_checkBox->isChecked());

	/*page PalmTracking*/
	palmtracking_checkBox->setChecked(this->apply_elanshm.SHM_palmtracking_checkBox);
	palmtracking_slider->setValue(this->apply_elanshm.SHM_palmtracking_slider);

	palmtracking_sensitivity_labe->setEnabled(palmtracking_checkBox->isChecked());
	palmtracking_slider->setEnabled(palmtracking_checkBox->isChecked());
	palmtracking_img->setEnabled(palmtracking_checkBox->isChecked());

	/*page Covergesture*/
	covergesture_checkBox->setChecked(this->apply_elanshm.SHM_covergesture_checkBox);
	covergestur_slider->setValue(this->apply_elanshm.SHM_covergesture_slider);
	covergesture_comboBox->setCurrentIndex(this->apply_elanshm.SHM_covergesture_comboBox);
	
	covergestur_sensitivity_labe->setEnabled(covergesture_checkBox->isChecked());
	covergestur_slider->setEnabled(covergesture_checkBox->isChecked());
	covergesture_img->setEnabled(covergesture_checkBox->isChecked());
	covergesture_options_label->setEnabled(covergesture_checkBox->isChecked());
	covergesture_comboBox->setEnabled(covergesture_checkBox->isChecked() );

	/*page General*/
	touchpad_checkBox->setChecked(!this->apply_elanshm.SHM_touch_checkBox);
	max_speed_slider->setValue((this->apply_elanshm.SHM_maxspeed_slider*1000.0));

	sensitivity_label->setEnabled(touchpad_checkBox->isChecked() );
	max_speed_slider->setEnabled(touchpad_checkBox->isChecked() );
	general_img->setEnabled(touchpad_checkBox->isChecked() );


	Button_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Tapping_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Scrolling_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Zoom_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Rotation_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Swipe_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Fast_Keys_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	Covergesture_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	PalmTracking_groupBox->setEnabled(touchpad_checkBox->isChecked() );
	
	return;
}

void	QElantouchPad::set_elanshm_value()
{
	char *command = (char *)malloc(128*sizeof(char));
		
	/*page General*/	
	sprintf(command,"elaclient2 TouchpadOff=%d ",this->apply_elanshm.SHM_touch_checkBox);
	system(command);
	#if debug_SHM_touch
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 MaxSpeed=%g ",this->apply_elanshm.SHM_maxspeed_slider);
	system(command);
	#if debug_SHM_maxspeed
	cout << command << endl;
	#endif

	/*page Button*/
	sprintf(command,"elaclient2 ButtonCheckBox=%d ",this->apply_elanshm.SHM_button_checkBox);
	system(command);
	#if debug_SHM_button_checkBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 ButtonLeftComboBox=%d ",this->apply_elanshm.SHM_button_left_comboBox);
	system(command);
	#if debug_SHM_button_left_comboBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 ButtonMiddleComboBox=%d ",this->apply_elanshm.SHM_button_middle_comboBox);
	system(command);
	#if debug_SHM_button_middle_comboBox
	cout << command << endl;
	#endif
	
	sprintf(command,"elaclient2 ButtonRightComboBox=%d ",this->apply_elanshm.SHM_button_right_comboBox);
	system(command);
	#if debug_SHM_button_right_comboBox
	cout << command << endl;
	#endif

	/*page Tapping*/
	sprintf(command,"elaclient2 TappingCheckBox=%d ",this->apply_elanshm.SHM_tapping_checkBox);
	#if 0
	if(this->apply_elanshm.SHM_tapping_checkBox)
		system("elaclient TapButton1=1");
	else
		system("elaclient TapButton1=0");
	#endif

	system(command);
	#if debug_SHM_tapping_checkBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 TwoFTComboBox=%d ",this->apply_elanshm.SHM_two_FT_comboBox);
	system(command);
	#if debug_SHM_two_FT_comboBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 ThreeFTComboBox=%d ",this->apply_elanshm.SHM_three_FT_comboBox);
	system(command);
	#if debug_SHM_three_FT_comboBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 DisableWhenKeyCheckBox=%d ",this->apply_elanshm.SHM_disable_when_key_checkBox);
	system(command);
	#if debug_SHM_disable_when_key_checkBox
	cout << command << endl;
	#endif
	
	sprintf(command,"elaclient2 TappingDelayComboBox=%d ",this->apply_elanshm.SHM_tapping_delay_comboBox);
	system(command);
	#if debug_SHM_tapping_delay_comboBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 CursorDelayComboBox=%d ",this->apply_elanshm.SHM_cursor_delay_comboBox);
	system(command);
	#if debug_SHM_cursor_delay_comboBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 CoverDelayComboBox=%d ",this->apply_elanshm.SHM_cover_delay_comboBox);
	system(command);
	#if debug_SHM_cover_delay_comboBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 GestureDelayComboBox=%d ",this->apply_elanshm.SHM_gesture_delay_comboBox);
	system(command);
	#if debug_SHM_gesture_delay_comboBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 PalmtrackDelayComboBox=%d ",this->apply_elanshm.SHM_palm_delay_comboBox);
	system(command);
	#if debug_SHM_palm_delay_comboBox
	cout << command << endl;
	#endif

	/*page Drag*/
	sprintf(command,"elaclient2 DragCheckBox=%d ",this->apply_elanshm.SHM_drag_checkBox);
	system(command);
	#if debug_SHM_drag_checkBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 LiftReleaseRadioButton=%d ",this->apply_elanshm.SHM_lift_release_radioButton);
	system(command);
	#if debug_SHM_drag_checkBox
	cout << command << endl;
	#endif


	sprintf(command,"elaclient2 DragCheckBox=%d ",this->apply_elanshm.SHM_drag_checkBox);
	system(command);
	#if debug_SHM_lift_release_radioButton
	cout << command << endl;
	#endif

	

	sprintf(command,"elaclient2 TapAgainRadioButton=%d ",this->apply_elanshm.SHM_tap_again_radioButton);
	system(command);
	#if debug_SHM_tap_again_radioButton
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 TapReleaseRadioButton=%d ",this->apply_elanshm.SHM_tap_release_radioButton);
	system(command);
	#if debug_SHM_tap_release_radioButton
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 DragSlider=%g ",this->apply_elanshm.SHM_drag_slider);
	system(command);
	#if debug_SHM_drag_slider
	cout << command << endl;
	#endif

	/*page Edge Scrolling*/
	sprintf(command,"elaclient2 EdgeVscrollCheckBox=%d ",this->apply_elanshm.SHM_edge_v_scroll_checkBox);
	system(command);
	#if debug_SHM_edge_v_scroll_checkBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 EdgeHscrollCheckBox=%d ",this->apply_elanshm.SHM_edge_h_scroll_checkBox);
	system(command);
	#if debug_SHM_edge_h_scroll_checkBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 EdgeScrollSpeedSlider=%d ",this->apply_elanshm.SHM_edge_scroll_speed_slider);
	system(command);
	#if debug_SHM_edge_scrolling_speed_slider
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 EdgeScrollAreaSlider=%d ",this->apply_elanshm.SHM_edge_scroll_area_slider);
	system(command);
	#if debug_SHM_edge_scrolling_area_slider
	cout << command << endl;
	#endif

	/*page Scrolling*/
	sprintf(command,"elaclient2 VerticalScrollingCheckBox=%d ",this->apply_elanshm.SHM_vertical_scrolling_checkBox);
	system(command);
	#if debug_SHM_vertical_scrolling_checkBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 HorizontalScrollingCheckBox=%d ",this->apply_elanshm.SHM_horizontal_scrolling_checkBox);
	system(command);
	#if debug_SHM_horizontal_scrolling_checkBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 ScrollingSpeedSlider=%d ",this->apply_elanshm.SHM_scrolling_speed_slider);
	system(command);
	#if debug_SHM_scrolling_speed_slider
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 AutoScrollCheckBox=%d ",this->apply_elanshm.SHM_auto_scroll_checkBox);
	system(command);
	#if debug_SHM_auto_scroll_checkBox
	cout << command << endl;
	#endif

	/*page Zoom*/
	sprintf(command,"elaclient2 ZoomCheckBox=%d ",this->apply_elanshm.SHM_zoom_checkBox);
	system(command);
	#if debug_SHM_zoom_checkBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 ZoomOutComboBox=%d ",this->apply_elanshm.SHM_zoom_out_comboBox);
	system(command);
	#if debug_SHM_zoom_out_comboBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 ZoomInComboBox=%d ",this->apply_elanshm.SHM_zoom_in_comboBox);
	system(command);
	#if debug_SHM_zoom_in_comboBox
	cout << command << endl;
	#endif
	
	sprintf(command,"elaclient2 ZoomSlider=%d ",this->apply_elanshm.SHM_zoom_slider);
	system(command);
	#if debug_SHM_zoom_slider
	cout << command << endl;
	#endif

	/*page Rotation*/
	sprintf(command,"elaclient2 RotationCheckBox=%d ",this->apply_elanshm.SHM_rotation_checkBox);
	system(command);
	#if debug_SHM_rotation_checkBox
	cout << command << endl;
	#endif
	
	sprintf(command,"elaclient2 ClockwiseComboBox=%d ",this->apply_elanshm.SHM_clockwise_comboBox);
	system(command);
	#if debug_SHM_clockwise_comboBox
	cout << command << endl;
	#endif
	
	sprintf(command,"elaclient2 CounterclosewiseComboBox=%d ",this->apply_elanshm.SHM_counterclosewise_comboBox);
	system(command);
	#if debug_SHM_counterclosewise_comboBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 RotationSlider=%d ",this->apply_elanshm.SHM_rotation_slider);
	system(command);
	#if debug_SHM_rotation_slider
	cout << command << endl;
	#endif

	/*page Swipe*/
	sprintf(command,"elaclient2 SwipePageCheckBox=%d ",this->apply_elanshm.SHM_swipe_page_checkBox);
	system(command);
	#if debug_SHM_swipe_page_checkBox
	cout << command << endl;
	#endif

	/*page Fast_keys*/
	sprintf(command,"elaclient2 FastKeyCheckBox=%d ",this->apply_elanshm.SHM_fast_key_checkBox);
	system(command);
	#if debug_SHM_fast_key_checkBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 MyHomeFileCheckBox=%d ",this->apply_elanshm.SHM_my_home_file_checkBox);
	system(command);
	#if debug_SHM_my_home_file_checkBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 SwitchWindowsCheckBox=%d ",this->apply_elanshm.SHM_switch_windows_checkBox);
	system(command);
	#if debug_SHM_switch_windows_checkBox
	cout << command << endl;
	#endif

	/*page Covergesture*/
	sprintf(command,"elaclient2 CovergestureCheckBox=%d ",this->apply_elanshm.SHM_covergesture_checkBox);
	system(command);
	#if debug_SHM_covergesture_checkBox
	cout << command << endl;
	#endif

	sprintf(command,"elaclient2 CovergestureSlider=%d ",this->apply_elanshm.SHM_covergesture_slider);
	system(command);
	#if debug_SHM_covergesture_slider
	cout << command << endl;
	#endif
	
	sprintf(command,"elaclient2 CovergestureComboBox=%d ",this->apply_elanshm.SHM_covergesture_comboBox);
	system(command);
	#if debug_SHM_covergesture_comboBox
	cout << command << endl;
	#endif	

	/*page PalmTracking*/
	sprintf(command,"elaclient2 PalmtrackingCheckBox=%d ",this->apply_elanshm.SHM_palmtracking_checkBox);
	system(command);
	#if debug_SHM_palmtracking_checkBox
	cout << command << endl;
	#endif
	
	sprintf(command,"elaclient2 PalmTrackingSlider=%d ",this->apply_elanshm.SHM_palmtracking_slider);
	system(command);
	#if debug_SHM_palmtracking_slider
	cout << command << endl;
	#endif

	return;

}

#if QtElanTrayIcon 
void	QElantouchPad::createTrayIconActions()
{
	//minimizeAction = new QAction(tr("minimize(&I)"),this);
	//connect(minimizeAction,SIGNAL(triggered()),this,SLOT(hide()));
	
	restoreAction = new QAction(tr("Property of Smart-Pad"),this);
	connect(restoreAction,SIGNAL(triggered()),this,SLOT(slot_iconPopMenu()));

	//quitAction = new QAction(tr("Quit(&Q)"),this);
	//connect(quitAction,SIGNAL(triggered()),qApp,SLOT(quit()));

}


void	QElantouchPad::createTrayIcon()
{
	trayIconMenu = new QMenu(this);
	//trayIconMenu->addAction(minimizeAction);
	trayIconMenu->addAction(restoreAction);	
	trayIconMenu->addSeparator();
	//trayIconMenu->addAction(quitAction);
	trayIcon->setContextMenu(trayIconMenu);
}
#endif

#if QtElantechtMultiLanguage
void QElantouchPad::change_help_file_TW()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHT/tp_patent.htm"));
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHT/tp_patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHT/tp_button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHT/tp_tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHT/tp_scroll.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHT/tp_zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHT/tp_rotation.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHT/tp_swipepage.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHT/tp_3fmovefunc.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHT/tp_cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHT/tp_palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHT/tp_drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHT/scroll_edge.htm"));
}
void QElantouchPad::change_help_file_CN()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHS/tp_patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHS/tp_button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHS/tp_tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHS/tp_scroll.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHS/tp_zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHS/tp_rotation.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHS/tp_swipepage.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHS/tp_3fmovefunc.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHS/tp_cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHS/tp_palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHS/tp_drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CHS/scroll_edge.htm"));
}
void QElantouchPad::change_help_file_US()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ENU/tp_patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ENU/tp_button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ENU/tp_tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ENU/tp_scroll.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ENU/tp_zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ENU/tp_rotation.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ENU/tp_swipepage.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ENU/tp_3fmovefunc.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ENU/tp_cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ENU/tp_palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ENU/tp_drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ENU/scroll_edge.htm"));
}
void QElantouchPad::change_help_file_JP()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/JPN/tp_patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/JPN/tp_button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/JPN/tp_tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/JPN/tp_scroll.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/JPN/tp_zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/JPN/tp_rotation.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/JPN/tp_swipepage.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/JPN/tp_3fmovefunc.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/JPN/tp_coverjp.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/JPN/tp_palmjp.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/JPN/tp_drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/JPN/scroll_edge.htm"));
}
void QElantouchPad::change_help_file_KR()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/KOR/tp_patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/KOR/tp_button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/KOR/tp_tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/KOR/tp_scroll.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/KOR/tp_zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/KOR/tp_rotation.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/KOR/tp_swipepage.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/KOR/tp_3fmovefunc.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/KOR/tp_cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/KOR/tp_palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/KOR/tp_drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/KOR/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_FR()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/FRA/tp_patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/FRA/tp_button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/FRA/tp_tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/FRA/tp_scroll.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/FRA/tp_zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/FRA/tp_rotation.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/FRA/tp_swipepage.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/FRA/tp_3fmovefunc.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/FRA/tp_cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/FRA/tp_palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/FRA/tp_drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/FRA/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_DE()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/DEU/tp_patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/DEU/tp_button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/DEU/tp_tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/DEU/tp_scroll.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/DEU/tp_zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/DEU/tp_rotation.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/DEU/tp_swipepage.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/DEU/tp_3fmovefunc.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/DEU/tp_cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/DEU/tp_palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/DEU/tp_drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/DEU/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_IT()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ITA/tp_patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ITA/tp_button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ITA/tp_tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ITA/tp_scroll.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ITA/tp_zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ITA/tp_rotation.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ITA/tp_swipepage.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ITA/tp_3fmovefunc.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ITA/tp_cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ITA/tp_palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ITA/tp_drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ITA/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_NL()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NLD/tp_patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NLD/tp_button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NLD/tp_tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NLD/tp_scroll.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NLD/tp_zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NLD/tp_rotation.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NLD/tp_swipepage.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NLD/tp_3fmovefunc.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NLD/tp_cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NLD/tp_palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NLD/tp_drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NLD/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_ES()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ESN/tp_patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ESN/tp_button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ESN/tp_tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ESN/tp_scroll.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ESN/tp_zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ESN/tp_rotation.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ESN/tp_swipepage.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ESN/tp_3fmovefunc.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ESN/tp_cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ESN/tp_palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ESN/tp_drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ESN/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_PT()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/POR/tp_patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/POR/tp_button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/POR/tp_tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/POR/tp_scroll.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/POR/tp_zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/POR/tp_rotation.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/POR/tp_swipepage.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/POR/tp_3fmovefunc.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/POR/tp_cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/POR/tp_palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/POR/tp_drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/POR/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_RU()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/RUS/tp_patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/RUS/tp_button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/RUS/tp_tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/RUS/tp_scroll.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/RUS/tp_zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/RUS/tp_rotation.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/RUS/tp_swipepage.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/RUS/tp_3fmovefunc.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/RUS/tp_cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/RUS/tp_palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/RUS/tp_drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/RUS/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_TH()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/THA/tp_patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/THA/tp_button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/THA/tp_tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/THA/tp_scroll.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/THA/tp_zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/THA/tp_rotation.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/THA/tp_swipepage.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/THA/tp_3fmovefunc.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/THA/tp_cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/THA/tp_palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/THA/tp_drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/THA/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_SE()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/SV/tp_patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/SV/tp_button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/SV/tp_tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/SV/tp_scroll.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/SV/tp_zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/SV/tp_rotation.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/SV/tp_swipepage.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/SV/tp_3fmovefunc.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/SV/tp_cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/SV/tp_palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/SV/tp_drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/SV/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_BR()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/BRA/tp_patent_Port_Marcia.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/BRA/tp_button_Port_Marcia.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/BRA/tp_tap_Port_Marcia.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/BRA/tp_scroll_Port_Marcia.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/BRA/tp_zoom_Port_Marcia.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/BRA/tp_rotation_Port_Marcia.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/BRA/tp_swipepage_Port_Marcia.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/BRA/tp_3fmovefunc_Port_Marcia.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/BRA/tp_cover_Port.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/BRA/tp_palm_Port_Marcia.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/BRA/tp_drag_Port_Marcia.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/BRA/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_ARA()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ARA/tp_patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ARA/tp_button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ARA/tp_tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ARA/tp_scroll.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ARA/tp_zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ARA/tp_rotation.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ARA/tp_swipepage.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ARA/tp_3fmovefunc.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ARA/tp_cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ARA/tp_palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ARA/tp_drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/ARA/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_CZ()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CZ/patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CZ/button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CZ/tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CZ/scroll2.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CZ/zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CZ/rotate.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CZ/swipe.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CZ/fast_key.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CZ/cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CZ/palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CZ/drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/CZ/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_Danish()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Danish/patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Danish/button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Danish/tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Danish/scroll2.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Danish/zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Danish/rotate.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Danish/swipe.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Danish/fast_key.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Danish/cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Danish/palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Danish/drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Danish/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_Finnish()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Finnish/patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Finnish/button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Finnish/tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Finnish/scroll2.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Finnish/zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Finnish/rotate.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Finnish/swipe.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Finnish/fast_key.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Finnish/cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Finnish/palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Finnish/drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Finnish/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_Greek()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Greek/patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Greek/button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Greek/tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Greek/scroll2.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Greek/zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Greek/rotate.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Greek/swipe.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Greek/fast_key.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Greek/cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Greek/palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Greek/drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Greek/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_HE()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/HE/patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/HE/button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/HE/tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/HE/scroll2.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/HE/zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/HE/rotate.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/HE/swipe.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/HE/fast_key.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/HE/cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/HE/palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/HE/drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/HE/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_Hungarian()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Hungarian/patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Hungarian/button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Hungarian/tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Hungarian/scroll2.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Hungarian/zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Hungarian/rotate.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Hungarian/swipe.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Hungarian/fast_key.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Hungarian/cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Hungarian/palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Hungarian/drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Hungarian/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_NO()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NO/patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NO/button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NO/tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NO/scroll2.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NO/zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NO/rotate.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NO/swipe.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NO/fast_key.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NO/cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NO/palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NO/drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/NO/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_PL()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/PL/patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/PL/button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/PL/tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/PL/scroll2.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/PL/zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/PL/rotate.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/PL/swipe.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/PL/fast_key.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/PL/cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/PL/palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/PL/drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/PL/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_Slovak()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Slovak/patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Slovak/button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Slovak/tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Slovak/scroll2.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Slovak/zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Slovak/rotate.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Slovak/swipe.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Slovak/fast_key.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Slovak/cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Slovak/palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Slovak/drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Slovak/scroll_edge.htm"));
}

void QElantouchPad::change_help_file_Turkish()
{
	elantech_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Turkish/patent.htm"));
	button_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Turkish/button.htm"));
	tapping_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Turkish/tap.htm"));
	scrolling_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Turkish/scroll2.htm"));
	zoom_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Turkish/zoom.htm"));
	rotation_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Turkish/rotate.htm"));
	swipe_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Turkish/swipe.htm"));
	fast_keys_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Turkish/fast_key.htm"));
	covergesture_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Turkish/cover.htm"));
	palmtracking_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Turkish/palm.htm"));
	drag_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Turkish/drag.htm"));
	edge_scroll_textBrowser->setSource(QUrl("/usr/share/elantouchpad_data/html/Turkish/scroll_edge.htm"));
}

void QElantouchPad::select_multi_language()
{
	if(QLocale::system().name()=="zh_TW")
	{
		change_help_file_TW();
	}
	else if(QLocale::system().name()=="en_US")
	{
		change_help_file_US();
	}
	else if(QLocale::system().name()=="zh_CN")
	{
		change_help_file_CN();
	}
	else if(QLocale::system().name()=="ja_JP")
	{
		change_help_file_JP();
	}
	else if(QLocale::system().name()=="ko_KR")
	{
		change_help_file_KR();
	}
	else if(QLocale::system().name()=="fr_FR")
	{
		change_help_file_FR();
	}
	else if(QLocale::system().name()=="de_DE")
	{
		change_help_file_DE();
	}
	else if(QLocale::system().name()=="it_IT")
	{
		change_help_file_IT();
	}
	else if(QLocale::system().name()=="nl_NL")
	{
		change_help_file_NL();
	}
	else if(QLocale::system().name()=="es_ES")
	{
		change_help_file_ES();
	}
	else if(QLocale::system().name()=="pt_PT")
	{
		change_help_file_PT();
	}
	else if(QLocale::system().name()=="ru_RU")
	{
		change_help_file_RU();
	}
	else if(QLocale::system().name()=="th_TH")
	{
		change_help_file_TH();
	}
	else if(QLocale::system().name()=="sv_SE")
	{
		change_help_file_SE();
	}
	else if(QLocale::system().name()=="pt_BR")
	{
		change_help_file_BR();
	}

	else if(QLocale::system().name()=="ar_SA")
	{
		change_help_file_ARA();
		setLayoutDirection(Qt::LayoutDirection(1));
	}
//--------------------------------------------------------------
	else if(QLocale::system().name()=="cs_CZ")
	{
		change_help_file_CZ();
	}

	else if(QLocale::system().name()=="da_DK")
	{
		change_help_file_Danish();
	}

	else if(QLocale::system().name()=="fi_FI")
	{
		change_help_file_Finnish();
	}

	else if(QLocale::system().name()=="el_CY")
	{
		change_help_file_Greek();
	}

	else if(QLocale::system().name()=="he_IL")
	{
		change_help_file_HE();
		setLayoutDirection(Qt::LayoutDirection(1));
	}

	else if(QLocale::system().name()=="hu_HU")
	{
		change_help_file_Hungarian();
	}

	else if(QLocale::system().name()=="pt_BR")
	{
		change_help_file_NO();
	}

	else if(QLocale::system().name()=="pl_PL")
	{
		change_help_file_PL();
	}

	else if(QLocale::system().name()=="sk_SK")
	{
		change_help_file_Slovak();
		
	}

	else if(QLocale::system().name()=="tr_TR")
	{
		change_help_file_Turkish();
	}

	else
	{
		change_help_file_US();
	}
}
#endif

void QElantouchPad::seltct_touchpad_style()
{
#if 1
	int shmid,i;
   	int first_cmd;
    	ElantechSHM *elashm;
	
	first_cmd = optind;
    	/* Connect to the shared memory area */
    	for(i=0;i<50;i++){
    		if ((shmid = shmget(SHM_ELANTECH, sizeof(ElantechSHM), 0)) == -1) {

        		if ((shmid = shmget(SHM_ELANTECH, 0, 0)) == -1) {
            			fprintf(stderr, "Can't access shared memory area. SHMConfig disabled?\n");
				if(i==49)
            				pthread_exit(NULL);
				else{
					usleep(1000);
					continue;

				}
        		} else {
            			fprintf(stderr, "Incorrect size of shared memory area. Incompatible driver version?\n");
            			if(i==49)
            				pthread_exit(NULL);
				else{
					usleep(1000);
					continue;

				}
        		}
    		}
    		if ((elashm = (ElantechSHM*) shmat(shmid, NULL, 0)) == NULL) {
        		perror("shmat");
        		if(i==49)
            			pthread_exit(NULL);
			else{
				usleep(1000);
				continue;

			}
    		}
		break;
    	}
	//cout<<"elashm->smart_pad="<<elashm->smart_pad<<"elashm->has_pressure="<<elashm->has_pressure<<" elashm->convergesture"<<elashm->convergesture <<endl; 
    	if(elashm->smart_pad==1 && elashm->has_pressure==1  && elashm->convergesture==1)
	{
		stackedWidget_2->setCurrentIndex(0);
	}
	else if(elashm->smart_pad==1 && elashm->has_pressure==1  && elashm->convergesture==0)
	{
		stackedWidget_2->setCurrentIndex(1);
		stackedWidget->removeWidget(covergesture_page);
	}
	else if(elashm->smart_pad==1 && elashm->has_pressure==0  && elashm->convergesture==0)
	{
		stackedWidget_2->setCurrentIndex(2);
		stackedWidget->removeWidget(covergesture_page);
		stackedWidget->removeWidget(palmtrack_page);
	}
	else if(elashm->smart_pad==0 && elashm->has_pressure==1  && elashm->convergesture==0)
	{
		stackedWidget_2->setCurrentIndex(3);
		stackedWidget->removeWidget(covergesture_page);
		stackedWidget->removeWidget(fastkay_page);
		stackedWidget->removeWidget(swipe_page);
		stackedWidget->removeWidget(rotation_page);
		stackedWidget->removeWidget(zoom_page);
	}
	else if(elashm->smart_pad==0 && elashm->has_pressure==0  && elashm->convergesture==0)
	{
		stackedWidget_2->setCurrentIndex(4);
		stackedWidget->removeWidget(covergesture_page);
		stackedWidget->removeWidget(palmtrack_page);
		stackedWidget->removeWidget(fastkay_page);
		stackedWidget->removeWidget(swipe_page);
		stackedWidget->removeWidget(rotation_page);
		stackedWidget->removeWidget(zoom_page);
	}
	else
	{
		stackedWidget_2->setCurrentIndex(4);
		stackedWidget->removeWidget(covergesture_page);
		stackedWidget->removeWidget(palmtrack_page);
		stackedWidget->removeWidget(fastkay_page);
		stackedWidget->removeWidget(swipe_page);
		stackedWidget->removeWidget(rotation_page);
		stackedWidget->removeWidget(zoom_page);
	}
#endif
}

QElantouchPad::QElantouchPad(QWidget *parent): QDialog(parent)
{
	setupUi(this);
	seltct_touchpad_style();
#if QtElantechtMultiLanguage
	select_multi_language();
#endif

#if debug_setup_ok
	cout << "step_1 setupUi OK" << endl;
#endif
	cur_elanshm_value();
#if debug_setup_ok
	cout << "step_2 cur_elanshm_value OK" << endl;
#endif
	catch_elanshm_value();
#if debug_setup_ok
	cout << "step_3 catch_elanshm_value OK" << endl;
#endif

#if QtElanTrayIcon
	/*TrayIcon setting*/
	QIcon icon = QIcon("/usr/share/elantouchpad_data/pixmaps/ElanIcon_middle.bmp");
	trayIcon = new QSystemTrayIcon(this);
	trayIcon->setIcon(icon);
	trayIcon->setToolTip("Elan Touch-Pad Preferences Setting");
	createTrayIconActions();
	createTrayIcon();
	trayIcon->show();
	//cout << "step_4 TrayIcon setting OK" << endl;
#endif
	/*Touchpad main panel*/


	
	/*page General*/
	connect(touchpad_checkBox, SIGNAL(clicked()), this, SLOT(slot_touchpadoff_checkBox()));
	connect(max_speed_slider, SIGNAL(valueChanged(int)), this, SLOT(slot_maxspeed_slider()));

	/*page Button*/
	connect(button_checkBox, SIGNAL(clicked()), this, SLOT(slot_button_checkBox()));
	connect(button_left_comboBox, SIGNAL(activated(int)), this, SLOT(slot_button_left_comboBox(int)));
	connect(button_middle_comboBox, SIGNAL(activated(int)), this, SLOT(slot_button_middle_comboBox(int)));
	connect(button_right_comboBox, SIGNAL(activated(int)), this, SLOT(slot_button_right_comboBox(int)));

	/*page Tapping*/
	connect(tapping_checkBox, SIGNAL(clicked()), this, SLOT(slot_tapping_checkBox()));
	connect(two_finger_comboBox, SIGNAL(activated(int)), this, SLOT(slot_two_FT_comboBox(int)));
	connect(three_finger_comboBox, SIGNAL(activated(int)), this, SLOT(slot_three_FT_comboBox(int)));
	connect(key_when_type_checkBox, SIGNAL(clicked()), this, SLOT(slot_disable_when_key_checkBox()));
	connect(tapping_delay_comboBox, SIGNAL(activated(int)), this, SLOT(slot_tapping_delay_comboBox(int)));
	connect(cursor_delay_comboBox, SIGNAL(activated(int)), this, SLOT(slot_cursor_delay_comboBox(int)));
	connect(cover_delay_comboBox, SIGNAL(activated(int)), this, SLOT(slot_cover_delay_comboBox(int)));
	connect(gesture_delay_comboBox, SIGNAL(activated(int)), this, SLOT(slot_gesture_delay_comboBox(int)));
	connect(palm_delay_comboBox, SIGNAL(activated(int)), this, SLOT(slot_palm_delay_comboBox(int)));

	/*page Drag*/
	connect(drag_checkBox, SIGNAL(clicked()), this, SLOT(slot_drag_checkBox()));
	connect(lift_release_radioButton,SIGNAL(clicked()), this, SLOT(slot_lift_release_radioButton()));
	connect(tap_again_radioButton,SIGNAL(clicked()), this, SLOT(slot_tap_again_radioButton()));
	connect(tap_release_radioButton,SIGNAL(clicked()), this, SLOT(slot_tap_release_radioButton()));
	connect(drag_slider,SIGNAL(valueChanged(int)), this, SLOT(slot_drag_slider()));

	/*page edge scrolling*/
	connect(edge_vertical_scrolling_checkBox, SIGNAL(clicked()), this, SLOT(slot_edge_v_scroll_checkBox()));
	connect(edge_horizontail_scrolling_checkBox, SIGNAL(clicked()), this, SLOT(slot_edge_h_scroll_checkBox()));
	connect(edge_scrolling_speed_slider, SIGNAL(valueChanged(int)), this, SLOT(slot_edge_scroll_speed_slider()));
	connect(edge_scrolling_area_slider, SIGNAL(valueChanged(int)), this, SLOT(slot_edge_scroll_area_slider()));

	/*page Scrolling*/
	connect(vertical_scrolling_checkBox, SIGNAL(clicked()), this, SLOT(slot_vertical_scrolling_checkBox()));
	connect(horizontail_scrolling_checkBox, SIGNAL(clicked()), this, SLOT(slot_horizontal_scrolling_checkBox()));
	connect(scroll_speed_slider, SIGNAL(valueChanged(int)), this, SLOT(slot_scrolling_speed_slider()));
	connect(auto_scroll_checkBox, SIGNAL(clicked()), this, SLOT(slot_auto_scroll_checkBox()));
	
	/*page Zoom*/
	connect(zoom_checkBox, SIGNAL(clicked()), this, SLOT(slot_zoom_checkBox()));
	connect(zoom_out_comboBox, SIGNAL(activated(int)), this, SLOT(slot_zoom_out_comboBox(int)));
	connect(zoom_in_comboBox, SIGNAL(activated(int)), this, SLOT(slot_zoom_in_comboBox(int)));
	connect(zoom_slider, SIGNAL(valueChanged(int)), this, SLOT(slot_zoom_slider()));

	/*page Rotation*/
	connect(rotation_checkBox, SIGNAL(clicked()), this, SLOT(slot_rotation_checkBox()));
	connect(clockwise_comboBox, SIGNAL(activated(int)), this, SLOT(slot_clockwise_comboBox(int)));
	connect(counterclockwise_comboBox, SIGNAL(activated(int)), this, SLOT(slot_counterclosewise_comboBox(int)));
	connect(rotation_slider, SIGNAL(valueChanged(int)), this, SLOT(slot_rotation_slider()));
	
	/*page Swipe*/
	connect(swipe_checkBox, SIGNAL(clicked()), this, SLOT(slot_swipe_page_checkBox()));

	/*page Fast_keys*/
	connect(fast_keys_checkBox, SIGNAL(clicked()), this, SLOT(slot_fast_key_checkBox()));
	connect(my_home_file_checkBox, SIGNAL(clicked()), this, SLOT(slot_my_home_file_checkBox()));
	connect(switch_windows_checkBox, SIGNAL(clicked()), this, SLOT(slot_switch_windows_checkBox()));

	/*page Covergesture*/
	connect(covergesture_checkBox, SIGNAL(clicked()), this, SLOT(slot_covergesture_checkBox()));
	connect(covergestur_slider, SIGNAL(valueChanged(int)), this, SLOT(slot_covergesture_slider()));
	connect(covergesture_comboBox, SIGNAL(activated(int)), this, SLOT(slot_covergesture_comboBox(int)));	

	/*page PalmTracking*/
	connect(palmtracking_checkBox, SIGNAL(clicked()), this, SLOT(slot_palmtracking_checkBox()));
	connect(palmtracking_slider, SIGNAL(valueChanged(int)), this, SLOT(slot_palmtracking_slider()));

	/*Push button*/
	connect(default_pushButton, SIGNAL(clicked()), this, SLOT(slot_default_pushbutton ()));
	connect(yes_pushButton, SIGNAL(clicked()), this, SLOT(slot_yes_pushbutton ()));
	connect(apple_pushButton, SIGNAL(clicked()), this, SLOT(slot_apply_pushbutton ()));
	connect(cancel_pushButton, SIGNAL(clicked()), this, SLOT(slot_cancel_pushbutton()));
	//connect(cancel_pushButton, SIGNAL(clicked()), this, SLOT(reject()));

#if QtElanTrayIcon	
	/*Tray Icon*/
	connect(trayIcon,SIGNAL(activated(QSystemTrayIcon::ActivationReason)),this,SLOT(slot_iconActivated(QSystemTrayIcon::ActivationReason)));
	
#endif	
	
}
