#ifndef _ELAN_LINUX_MAIN_H__
#define	_ELAN_LINUX_MAIN_H__

#include <fcntl.h>
#include <errno.h>
#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>
#include <semaphore.h>
#include <stddef.h>
#include <math.h>
#include <stdlib.h>

#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/shm.h>
#include <sys/time.h>
#include <sys/timeb.h>



#include <X11/Xdefs.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xatom.h>
#include <X11/Xmu/CurUtil.h>
#include "X11/bitmaps/gray"

#include "linux_input.h"
#include "elantech.h"
#include "data_thread.h"
#include "ctrl_thread.h"
#include "hotkey_thread.h"

#include "auto_scroll_thread.h"

sem_t get_data_sem,ctrl_data_sem,ctrl_drag_sem,auto_scroll_sem;
int tap_timeout_release;
int cover_gesture_release;
int swipe_release;


#endif